require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&__i386__)) {
    eval 'sub ELF32_MACHDEP_ENDIANNESS () { &ELFDATA2LSB;}' unless defined(&ELF32_MACHDEP_ENDIANNESS);
    eval 'sub ELF32_MACHDEP_ID_CASES () { &case  &EM_386:  &break;;}' unless defined(&ELF32_MACHDEP_ID_CASES);
    eval 'sub ELF64_MACHDEP_ENDIANNESS () { &ELFDATA2LSB;}' unless defined(&ELF64_MACHDEP_ENDIANNESS);
    eval 'sub ELF64_MACHDEP_ID_CASES () { &case  &EM_X86_64:  &break;;}' unless defined(&ELF64_MACHDEP_ID_CASES);
    eval 'sub ELF32_MACHDEP_ID () { &EM_386;}' unless defined(&ELF32_MACHDEP_ID);
    eval 'sub ELF64_MACHDEP_ID () { &EM_X86_64;}' unless defined(&ELF64_MACHDEP_ID);
    eval 'sub KERN_ELFSIZE () {64;}' unless defined(&KERN_ELFSIZE);
    eval 'sub ARCH_ELFSIZE () {64;}' unless defined(&ARCH_ELFSIZE);
    eval 'sub R_X86_64_NONE () {0;}' unless defined(&R_X86_64_NONE);
    eval 'sub R_X86_64_64 () {1;}' unless defined(&R_X86_64_64);
    eval 'sub R_X86_64_PC32 () {2;}' unless defined(&R_X86_64_PC32);
    eval 'sub R_X86_64_GOT32 () {3;}' unless defined(&R_X86_64_GOT32);
    eval 'sub R_X86_64_PLT32 () {4;}' unless defined(&R_X86_64_PLT32);
    eval 'sub R_X86_64_COPY () {5;}' unless defined(&R_X86_64_COPY);
    eval 'sub R_X86_64_GLOB_DAT () {6;}' unless defined(&R_X86_64_GLOB_DAT);
    eval 'sub R_X86_64_JUMP_SLOT () {7;}' unless defined(&R_X86_64_JUMP_SLOT);
    eval 'sub R_X86_64_RELATIVE () {8;}' unless defined(&R_X86_64_RELATIVE);
    eval 'sub R_X86_64_GOTPCREL () {9;}' unless defined(&R_X86_64_GOTPCREL);
    eval 'sub R_X86_64_32 () {10;}' unless defined(&R_X86_64_32);
    eval 'sub R_X86_64_32S () {11;}' unless defined(&R_X86_64_32S);
    eval 'sub R_X86_64_16 () {12;}' unless defined(&R_X86_64_16);
    eval 'sub R_X86_64_PC16 () {13;}' unless defined(&R_X86_64_PC16);
    eval 'sub R_X86_64_8 () {14;}' unless defined(&R_X86_64_8);
    eval 'sub R_X86_64_PC8 () {15;}' unless defined(&R_X86_64_PC8);
    eval 'sub R_X86_64_DTPMOD64 () {16;}' unless defined(&R_X86_64_DTPMOD64);
    eval 'sub R_X86_64_DTPOFF64 () {17;}' unless defined(&R_X86_64_DTPOFF64);
    eval 'sub R_X86_64_TPOFF64 () {18;}' unless defined(&R_X86_64_TPOFF64);
    eval 'sub R_X86_64_TLSGD () {19;}' unless defined(&R_X86_64_TLSGD);
    eval 'sub R_X86_64_TLSLD () {20;}' unless defined(&R_X86_64_TLSLD);
    eval 'sub R_X86_64_DTPOFF32 () {21;}' unless defined(&R_X86_64_DTPOFF32);
    eval 'sub R_X86_64_GOTTPOFF () {22;}' unless defined(&R_X86_64_GOTTPOFF);
    eval 'sub R_X86_64_TPOFF32 () {23;}' unless defined(&R_X86_64_TPOFF32);
    eval 'sub R_X86_64_PC64 () {24;}' unless defined(&R_X86_64_PC64);
    eval 'sub R_X86_64_GOTOFF64 () {25;}' unless defined(&R_X86_64_GOTOFF64);
    eval 'sub R_X86_64_GOTPC32 () {26;}' unless defined(&R_X86_64_GOTPC32);
    eval 'sub R_X86_64_GOT64 () {27;}' unless defined(&R_X86_64_GOT64);
    eval 'sub R_X86_64_GOTPCREL64 () {28;}' unless defined(&R_X86_64_GOTPCREL64);
    eval 'sub R_X86_64_GOTPC64 () {29;}' unless defined(&R_X86_64_GOTPC64);
    eval 'sub R_X86_64_GOTPLT64 () {30;}' unless defined(&R_X86_64_GOTPLT64);
    eval 'sub R_X86_64_PLTOFF64 () {31;}' unless defined(&R_X86_64_PLTOFF64);
    eval 'sub R_X86_64_SIZE32 () {32;}' unless defined(&R_X86_64_SIZE32);
    eval 'sub R_X86_64_SIZE64 () {33;}' unless defined(&R_X86_64_SIZE64);
    eval 'sub R_X86_64_GOTPC32_TLSDESC () {34;}' unless defined(&R_X86_64_GOTPC32_TLSDESC);
    eval 'sub R_X86_64_TLSDESC_CALL () {35;}' unless defined(&R_X86_64_TLSDESC_CALL);
    eval 'sub R_X86_64_TLSDESC () {36;}' unless defined(&R_X86_64_TLSDESC);
    eval 'sub R_X86_64_IRELATIVE () {37;}' unless defined(&R_X86_64_IRELATIVE);
    eval 'sub R_X86_64_RELATIVE64 () {38;}' unless defined(&R_X86_64_RELATIVE64);
    eval 'sub R_X86_64_PC32_BND () {39;}' unless defined(&R_X86_64_PC32_BND);
    eval 'sub R_X86_64_PLT32_BND () {40;}' unless defined(&R_X86_64_PLT32_BND);
    eval 'sub R_X86_64_GOTPCRELX () {41;}' unless defined(&R_X86_64_GOTPCRELX);
    eval 'sub R_X86_64_REX_GOTPCRELX () {42;}' unless defined(&R_X86_64_REX_GOTPCRELX);
    eval 'sub R_TYPE {
        my($name) = @_;
	    eval q( &__CONCAT( &R_X86_64_,$name));
    }' unless defined(&R_TYPE);
} else {
    require 'i386/elf_machdep.ph';
}
1;
