require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_AMD64_FRAME_REGS_H_)) {
    eval 'sub _AMD64_FRAME_REGS_H_ () {1;}' unless defined(&_AMD64_FRAME_REGS_H_);
    eval 'sub _FRAME_REG {
        my($greg, $freg) = @_;
	    eval q($greg( &rdi,  &RDI, 0) $greg( &rsi,  &RSI, 1) $greg( &rdx,  &RDX, 2) $greg( &r10,  &R10, 6) $greg( &r8,  &R8, 4) $greg( &r9,  &R9, 5) $freg( &arg6, @, @) $freg( &arg7, @, @) $freg( &arg8, @, @) $freg( &arg9, @, @) $greg( &rcx,  &RCX, 3) $greg( &r11,  &R11, 7) $greg( &r12,  &R12, 8) $greg( &r13,  &R13, 9) $greg( &r14,  &R14, 10) $greg( &r15,  &R15, 11) $greg( &rbp,  &RBP, 12) $greg( &rbx,  &RBX, 13) $greg( &rax,  &RAX, 14) $greg( &gs,  &GS, 15) $greg( &fs,  &FS, 16) $greg( &es,  &ES, 17) $greg( &ds,  &DS, 18) $greg( &trapno,  &TRAPNO, 19) $greg( &err,  &ERR, 20) $greg( &rip,  &RIP, 21) $greg( &cs,  &CS, 22) $greg( &rflags,  &RFLAGS, 23) $greg( &rsp,  &RSP, 24) $greg( &ss,  &SS, 25));
    }' unless defined(&_FRAME_REG);
    eval 'sub _FRAME_NOREG {
        my($reg, $REG, $idx) = @_;
	    eval q();
    }' unless defined(&_FRAME_NOREG);
    eval 'sub _FRAME_GREG {
        my($greg) = @_;
	    eval q( &_FRAME_REG($greg,  &_FRAME_NOREG));
    }' unless defined(&_FRAME_GREG);
}
1;
