require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_NETBSD32_H_)) {
    eval 'sub _MACHINE_NETBSD32_H_ () {1;}' unless defined(&_MACHINE_NETBSD32_H_);
    require 'sys/ucontext.ph';
    require 'compat/sys/ucontext.ph';
    require 'compat/sys/siginfo.ph';
    require 'x86/fpu.ph';
    eval 'sub PT32_STEP () {( &PT_FIRSTMACH + 0);}' unless defined(&PT32_STEP);
    eval 'sub PT32_GETREGS () {( &PT_FIRSTMACH + 1);}' unless defined(&PT32_GETREGS);
    eval 'sub PT32_SETREGS () {( &PT_FIRSTMACH + 2);}' unless defined(&PT32_SETREGS);
    eval 'sub PT32_GETFPREGS () {( &PT_FIRSTMACH + 3);}' unless defined(&PT32_GETFPREGS);
    eval 'sub PT32_SETFPREGS () {( &PT_FIRSTMACH + 4);}' unless defined(&PT32_SETFPREGS);
    eval 'sub PT32_GETXMMREGS () {( &PT_FIRSTMACH + 5);}' unless defined(&PT32_GETXMMREGS);
    eval 'sub PT32_SETXMMREGS () {( &PT_FIRSTMACH + 6);}' unless defined(&PT32_SETXMMREGS);
    eval 'sub PT32_GETDBREGS () {( &PT_FIRSTMACH + 7);}' unless defined(&PT32_GETDBREGS);
    eval 'sub PT32_SETDBREGS () {( &PT_FIRSTMACH + 8);}' unless defined(&PT32_SETDBREGS);
    eval 'sub PT32_SETSTEP () {( &PT_FIRSTMACH + 9);}' unless defined(&PT32_SETSTEP);
    eval 'sub PT32_CLEARSTEP () {( &PT_FIRSTMACH + 10);}' unless defined(&PT32_CLEARSTEP);
    eval 'sub PT32_GETXSTATE () {( &PT_FIRSTMACH + 11);}' unless defined(&PT32_GETXSTATE);
    eval 'sub PT32_SETXSTATE () {( &PT_FIRSTMACH + 12);}' unless defined(&PT32_SETXSTATE);
    eval 'sub NETBSD32_POINTER_TYPE () { &uint32_t;}' unless defined(&NETBSD32_POINTER_TYPE);
    eval 'sub NETBSD32_INT64_ALIGN () { &__attribute__(( &__aligned__(4)));}' unless defined(&NETBSD32_INT64_ALIGN);
    eval 'sub sc_sp () { &sc_esp;}' unless defined(&sc_sp);
    eval 'sub sc_fp () { &sc_ebp;}' unless defined(&sc_fp);
    eval 'sub sc_pc () { &sc_eip;}' unless defined(&sc_pc);
    eval 'sub sc_ps () { &sc_eflags;}' unless defined(&sc_ps);
    eval 'sub NETBSD32_MID_MACHINE () { &MID_I386;}' unless defined(&NETBSD32_MID_MACHINE);
}
1;
