require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <adxintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_ADXINTRIN_H_INCLUDED)) {
    eval 'sub _ADXINTRIN_H_INCLUDED () {1;}' unless defined(&_ADXINTRIN_H_INCLUDED);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_subborrow_u32 (my $__CF, my $__X, my $__Y, my $int * &__P) {  &__builtin_ia32_sbb_u32 ( $__CF,  $__X,  $__Y,  &__P); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_addcarry_u32 (my $__CF, my $__X, my $__Y, my $int * &__P) {  &__builtin_ia32_addcarryx_u32 ( $__CF,  $__X,  $__Y,  &__P); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_addcarryx_u32 (my $__CF, my $__X, my $__Y, my $int * &__P) {  &__builtin_ia32_addcarryx_u32 ( $__CF,  $__X,  $__Y,  &__P); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_subborrow_u64 (my $__CF, my $__X, my $__Y, my $long * &__P) {  &__builtin_ia32_sbb_u64 ( $__CF,  $__X,  $__Y,  &__P); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_addcarry_u64 (my $__CF, my $__X, my $__Y, my $long * &__P) {  &__builtin_ia32_addcarryx_u64 ( $__CF,  $__X,  $__Y,  &__P); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_addcarryx_u64 (my $__CF, my $__X, my $__Y, my $long * &__P) {  &__builtin_ia32_addcarryx_u64 ( $__CF,  $__X,  $__Y,  &__P); });
	}' unless defined(&__attribute__);
    }
}
1;
