require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512vp2intersectintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512VP2INTERSECTVLINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512VP2INTERSECTVLINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512VP2INTERSECTVLINTRIN_H_INCLUDED);
    if(!defined(&__AVX512VP2INTERSECT__) || !defined(&__AVX512VL__)) {
	eval 'sub __DISABLE_AVX512VP2INTERSECTVL__ () {1;}' unless defined(&__DISABLE_AVX512VP2INTERSECTVL__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_2intersect_epi32 ( &__m128i  &__A,  &__m128i  &__B,  &__mmask8 * &__U,  &__mmask8 * &__M) {  &__builtin_ia32_2intersectd128 ( &__U,  &__M, ( &__v4si)  &__A, ( &__v4si)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_2intersect_epi32 ( &__m256i  &__A,  &__m256i  &__B,  &__mmask8 * &__U,  &__mmask8 * &__M) {  &__builtin_ia32_2intersectd256 ( &__U,  &__M, ( &__v8si)  &__A, ( &__v8si)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_2intersect_epi64 ( &__m128i  &__A,  &__m128i  &__B,  &__mmask8 * &__U,  &__mmask8 * &__M) {  &__builtin_ia32_2intersectq128 ( &__U,  &__M, ( &__v2di)  &__A, ( &__v2di)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_2intersect_epi64 ( &__m256i  &__A,  &__m256i  &__B,  &__mmask8 * &__U,  &__mmask8 * &__M) {  &__builtin_ia32_2intersectq256 ( &__U,  &__M, ( &__v4di)  &__A, ( &__v4di)  &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_AVX512VP2INTERSECTVL__)) {
	undef(&__DISABLE_AVX512VP2INTERSECTVL__) if defined(&__DISABLE_AVX512VP2INTERSECTVL__);
    }
}
1;
