require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512vpopcntdqvlintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512VPOPCNTDQVLINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512VPOPCNTDQVLINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512VPOPCNTDQVLINTRIN_H_INCLUDED);
    if(!defined(&__AVX512VPOPCNTDQ__) || !defined(&__AVX512VL__)) {
	eval 'sub __DISABLE_AVX512VPOPCNTDQVL__ () {1;}' unless defined(&__DISABLE_AVX512VPOPCNTDQVL__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_popcnt_epi32 ( &__m128i  &__A) { ( &__m128i)  &__builtin_ia32_vpopcountd_v4si (( &__v4si)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_popcnt_epi32 ( &__m128i  &__W,  &__mmask16  &__U,  &__m128i  &__A) { ( &__m128i)  &__builtin_ia32_vpopcountd_v4si_mask (( &__v4si)  &__A, ( &__v4si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_popcnt_epi32 ( &__mmask16  &__U,  &__m128i  &__A) { ( &__m128i)  &__builtin_ia32_vpopcountd_v4si_mask (( &__v4si)  &__A, ( &__v4si)  &_mm_setzero_si128 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_popcnt_epi32 ( &__m256i  &__A) { ( &__m256i)  &__builtin_ia32_vpopcountd_v8si (( &__v8si)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_popcnt_epi32 ( &__m256i  &__W,  &__mmask16  &__U,  &__m256i  &__A) { ( &__m256i)  &__builtin_ia32_vpopcountd_v8si_mask (( &__v8si)  &__A, ( &__v8si)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_popcnt_epi32 ( &__mmask16  &__U,  &__m256i  &__A) { ( &__m256i)  &__builtin_ia32_vpopcountd_v8si_mask (( &__v8si)  &__A, ( &__v8si)  &_mm256_setzero_si256 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_popcnt_epi64 ( &__m128i  &__A) { ( &__m128i)  &__builtin_ia32_vpopcountq_v2di (( &__v2di)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_popcnt_epi64 ( &__m128i  &__W,  &__mmask8  &__U,  &__m128i  &__A) { ( &__m128i)  &__builtin_ia32_vpopcountq_v2di_mask (( &__v2di)  &__A, ( &__v2di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_popcnt_epi64 ( &__mmask8  &__U,  &__m128i  &__A) { ( &__m128i)  &__builtin_ia32_vpopcountq_v2di_mask (( &__v2di)  &__A, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_popcnt_epi64 ( &__m256i  &__A) { ( &__m256i)  &__builtin_ia32_vpopcountq_v4di (( &__v4di)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_mask_popcnt_epi64 ( &__m256i  &__W,  &__mmask8  &__U,  &__m256i  &__A) { ( &__m256i)  &__builtin_ia32_vpopcountq_v4di_mask (( &__v4di)  &__A, ( &__v4di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_maskz_popcnt_epi64 ( &__mmask8  &__U,  &__m256i  &__A) { ( &__m256i)  &__builtin_ia32_vpopcountq_v4di_mask (( &__v4di)  &__A, ( &__v4di)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_AVX512VPOPCNTDQVL__)) {
	undef(&__DISABLE_AVX512VPOPCNTDQVL__) if defined(&__DISABLE_AVX512VPOPCNTDQVL__);
    }
}
1;
