require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_X86INTRIN_H_INCLUDED)  && !defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <bmi2intrin.h> directly; include <x86intrin.h> instead.");
}
unless(defined(&_BMI2INTRIN_H_INCLUDED)) {
    eval 'sub _BMI2INTRIN_H_INCLUDED () {1;}' unless defined(&_BMI2INTRIN_H_INCLUDED);
    unless(defined(&__BMI2__)) {
	eval 'sub __DISABLE_BMI2__ () {1;}' unless defined(&__DISABLE_BMI2__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_bzhi_u32 (my $__X, my $__Y) {  &__builtin_ia32_bzhi_si ( $__X,  $__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_pdep_u32 (my $__X, my $__Y) {  &__builtin_ia32_pdep_si ( $__X,  $__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_pext_u32 (my $__X, my $__Y) {  &__builtin_ia32_pext_si ( $__X,  $__Y); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_bzhi_u64 (my $__X, my $__Y) {  &__builtin_ia32_bzhi_di ( $__X,  $__Y); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_pdep_u64 (my $__X, my $__Y) {  &__builtin_ia32_pdep_di ( $__X,  $__Y); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_pext_u64 (my $__X, my $__Y) {  &__builtin_ia32_pext_di ( $__X,  $__Y); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mulx_u64 (my $__X, my $__Y, my $long * &__P) { \'unsigned __int128 __res\' =   $__X *  $__Y; * &__P = ( &__res >> 64);  &__res; });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mulx_u32 (my $__X, my $__Y, my $int * &__P) { my $__res =  $__X *  $__Y; * &__P = ( $__res >> 32);  $__res; });
	}' unless defined(&__attribute__);
    }
    if(defined(&__DISABLE_BMI2__)) {
	undef(&__DISABLE_BMI2__) if defined(&__DISABLE_BMI2__);
    }
}
1;
