require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <rdseedintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_RDSEEDINTRIN_H_INCLUDED)) {
    eval 'sub _RDSEEDINTRIN_H_INCLUDED () {1;}' unless defined(&_RDSEEDINTRIN_H_INCLUDED);
    unless(defined(&__RDSEED__)) {
	eval 'sub __DISABLE_RDSEED__ () {1;}' unless defined(&__DISABLE_RDSEED__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_rdseed16_step (my $short * &__p) {  &__builtin_ia32_rdseed_hi_step ( &__p); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_rdseed32_step (my $int * &__p) {  &__builtin_ia32_rdseed_si_step ( &__p); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_rdseed64_step (my $long * &__p) {  &__builtin_ia32_rdseed_di_step ( &__p); });
	}' unless defined(&__attribute__);
    }
    if(defined(&__DISABLE_RDSEED__)) {
	undef(&__DISABLE_RDSEED__) if defined(&__DISABLE_RDSEED__);
    }
}
1;
