require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_AMD64_PTE_H_)) {
    eval 'sub _AMD64_PTE_H_ () {1;}' unless defined(&_AMD64_PTE_H_);
    if(defined(&__x86_64__)) {
	if(!defined(&_LOCORE)) {
	    require 'sys/stdint.ph';
	}
	eval 'sub VA_SIGN_MASK () {0xffff000000000000;}' unless defined(&VA_SIGN_MASK);
	eval 'sub VA_SIGN_NEG {
	    my($va) = @_;
    	    eval q((($va) |  &VA_SIGN_MASK));
	}' unless defined(&VA_SIGN_NEG);
	eval 'sub VA_SIGN_POS {
	    my($va) = @_;
    	    eval q((($va) & ~ &VA_SIGN_MASK));
	}' unless defined(&VA_SIGN_POS);
	eval 'sub L1_SHIFT () {12;}' unless defined(&L1_SHIFT);
	eval 'sub L2_SHIFT () {21;}' unless defined(&L2_SHIFT);
	eval 'sub L3_SHIFT () {30;}' unless defined(&L3_SHIFT);
	eval 'sub L4_SHIFT () {39;}' unless defined(&L4_SHIFT);
	eval 'sub NBPD_L1 () {(1 <<  &L1_SHIFT);}' unless defined(&NBPD_L1);
	eval 'sub NBPD_L2 () {(1 <<  &L2_SHIFT);}' unless defined(&NBPD_L2);
	eval 'sub NBPD_L3 () {(1 <<  &L3_SHIFT);}' unless defined(&NBPD_L3);
	eval 'sub NBPD_L4 () {(1 <<  &L4_SHIFT);}' unless defined(&NBPD_L4);
	eval 'sub L4_MASK () {0xff8000000000;}' unless defined(&L4_MASK);
	eval 'sub L3_MASK () {0x7fc0000000;}' unless defined(&L3_MASK);
	eval 'sub L2_MASK () {0x3fe00000;}' unless defined(&L2_MASK);
	eval 'sub L1_MASK () {0x1ff000;}' unless defined(&L1_MASK);
	eval 'sub L4_FRAME () { &L4_MASK;}' unless defined(&L4_FRAME);
	eval 'sub L3_FRAME () {( &L4_FRAME| &L3_MASK);}' unless defined(&L3_FRAME);
	eval 'sub L2_FRAME () {( &L3_FRAME| &L2_MASK);}' unless defined(&L2_FRAME);
	eval 'sub L1_FRAME () {( &L2_FRAME| &L1_MASK);}' unless defined(&L1_FRAME);
	eval 'sub PTE_P () {0x1;}' unless defined(&PTE_P);
	eval 'sub PTE_W () {0x2;}' unless defined(&PTE_W);
	eval 'sub PTE_U () {0x4;}' unless defined(&PTE_U);
	eval 'sub PTE_PWT () {0x8;}' unless defined(&PTE_PWT);
	eval 'sub PTE_PCD () {0x10;}' unless defined(&PTE_PCD);
	eval 'sub PTE_A () {0x20;}' unless defined(&PTE_A);
	eval 'sub PTE_D () {0x40;}' unless defined(&PTE_D);
	eval 'sub PTE_PAT () {0x80;}' unless defined(&PTE_PAT);
	eval 'sub PTE_PS () {0x80;}' unless defined(&PTE_PS);
	eval 'sub PTE_G () {0x100;}' unless defined(&PTE_G);
	eval 'sub PTE_AVL1 () {0x200;}' unless defined(&PTE_AVL1);
	eval 'sub PTE_AVL2 () {0x400;}' unless defined(&PTE_AVL2);
	eval 'sub PTE_AVL3 () {0x800;}' unless defined(&PTE_AVL3);
	eval 'sub PTE_LGPAT () {0x1000;}' unless defined(&PTE_LGPAT);
	eval 'sub PTE_NX () {0x8000000000000000;}' unless defined(&PTE_NX);
	eval 'sub PTE_4KFRAME () {0xffffffffff000;}' unless defined(&PTE_4KFRAME);
	eval 'sub PTE_2MFRAME () {0xfffffffe00000;}' unless defined(&PTE_2MFRAME);
	eval 'sub PTE_1GFRAME () {0xfffffc0000000;}' unless defined(&PTE_1GFRAME);
	eval 'sub PTE_FRAME () { &PTE_4KFRAME;}' unless defined(&PTE_FRAME);
	eval 'sub PTE_LGFRAME () { &PTE_2MFRAME;}' unless defined(&PTE_LGFRAME);
	eval 'sub _MACHINE_PTE_H_X86 () {1;}' unless defined(&_MACHINE_PTE_H_X86);
	require 'x86/pte.ph';
	undef(&_MACHINE_PTE_H_X86) if defined(&_MACHINE_PTE_H_X86);
    } else {
	require 'i386/pte.ph';
    }
}
1;
