require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512dqintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512DQINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512DQINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512DQINTRIN_H_INCLUDED);
    unless(defined(&__AVX512DQ__)) {
	eval 'sub __DISABLE_AVX512DQ__ () {1;}' unless defined(&__DISABLE_AVX512DQ__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_ktest_mask8_u8 ( &__mmask8  &__A,  &__mmask8  &__B, my $char * &__CF) { * &__CF =  &__builtin_ia32_ktestcqi ( &__A,  &__B);  &__builtin_ia32_ktestzqi ( &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_ktestz_mask8_u8 ( &__mmask8  &__A,  &__mmask8  &__B) {  &__builtin_ia32_ktestzqi ( &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_ktestc_mask8_u8 ( &__mmask8  &__A,  &__mmask8  &__B) {  &__builtin_ia32_ktestcqi ( &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_ktest_mask16_u8 ( &__mmask16  &__A,  &__mmask16  &__B, my $char * &__CF) { * &__CF =  &__builtin_ia32_ktestchi ( &__A,  &__B);  &__builtin_ia32_ktestzhi ( &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_ktestz_mask16_u8 ( &__mmask16  &__A,  &__mmask16  &__B) {  &__builtin_ia32_ktestzhi ( &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_ktestc_mask16_u8 ( &__mmask16  &__A,  &__mmask16  &__B) {  &__builtin_ia32_ktestchi ( &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kortest_mask8_u8 ( &__mmask8  &__A,  &__mmask8  &__B, my $char * &__CF) { * &__CF =  &__builtin_ia32_kortestcqi ( &__A,  &__B);  &__builtin_ia32_kortestzqi ( &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kortestz_mask8_u8 ( &__mmask8  &__A,  &__mmask8  &__B) {  &__builtin_ia32_kortestzqi ( &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kortestc_mask8_u8 ( &__mmask8  &__A,  &__mmask8  &__B) {  &__builtin_ia32_kortestcqi ( &__A,  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kadd_mask8 ( &__mmask8  &__A,  &__mmask8  &__B) { ( &__mmask8)  &__builtin_ia32_kaddqi (( &__mmask8)  &__A, ( &__mmask8)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kadd_mask16 ( &__mmask16  &__A,  &__mmask16  &__B) { ( &__mmask16)  &__builtin_ia32_kaddhi (( &__mmask16)  &__A, ( &__mmask16)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_cvtmask8_u32 {  &__builtin_ia32_kmovb (( &__mmask8 )  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_load_mask8 ( &__mmask8 * &__A) { ( &__mmask8)  &__builtin_ia32_kmovb (*( &__mmask8 *)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_store_mask8 ( &__mmask8 * &__A,  &__mmask8  &__B) { *( &__mmask8 *)  &__A =  &__builtin_ia32_kmovb ( &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_knot_mask8 ( &__mmask8  &__A) { ( &__mmask8)  &__builtin_ia32_knotqi (( &__mmask8)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kor_mask8 ( &__mmask8  &__A,  &__mmask8  &__B) { ( &__mmask8)  &__builtin_ia32_korqi (( &__mmask8)  &__A, ( &__mmask8)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kxnor_mask8 ( &__mmask8  &__A,  &__mmask8  &__B) { ( &__mmask8)  &__builtin_ia32_kxnorqi (( &__mmask8)  &__A, ( &__mmask8)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kxor_mask8 ( &__mmask8  &__A,  &__mmask8  &__B) { ( &__mmask8)  &__builtin_ia32_kxorqi (( &__mmask8)  &__A, ( &__mmask8)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kand_mask8 ( &__mmask8  &__A,  &__mmask8  &__B) { ( &__mmask8)  &__builtin_ia32_kandqi (( &__mmask8)  &__A, ( &__mmask8)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kandn_mask8 ( &__mmask8  &__A,  &__mmask8  &__B) { ( &__mmask8)  &__builtin_ia32_kandnqi (( &__mmask8)  &__A, ( &__mmask8)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcast_f64x2 ( &__m128d  &__A) { ( &__m512d)  &__builtin_ia32_broadcastf64x2_512_mask (( &__v2df)  &__A,  &_mm512_undefined_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcast_f64x2 ( &__m512d  &__O,  &__mmask8  &__M,  &__m128d  &__A) { ( &__m512d)  &__builtin_ia32_broadcastf64x2_512_mask (( &__v2df)  &__A, ( &__v8df)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcast_f64x2 ( &__mmask8  &__M,  &__m128d  &__A) { ( &__m512d)  &__builtin_ia32_broadcastf64x2_512_mask (( &__v2df)  &__A, ( &__v8df)  &_mm512_setzero_ps (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcast_i64x2 ( &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti64x2_512_mask (( &__v2di)  &__A,  &_mm512_undefined_epi32 (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcast_i64x2 ( &__m512i  &__O,  &__mmask8  &__M,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti64x2_512_mask (( &__v2di)  &__A, ( &__v8di)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcast_i64x2 ( &__mmask8  &__M,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti64x2_512_mask (( &__v2di)  &__A, ( &__v8di)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcast_f32x2 ( &__m128  &__A) { ( &__m512)  &__builtin_ia32_broadcastf32x2_512_mask (( &__v4sf)  &__A, ( &__v16sf) &_mm512_undefined_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcast_f32x2 ( &__m512  &__O,  &__mmask16  &__M,  &__m128  &__A) { ( &__m512)  &__builtin_ia32_broadcastf32x2_512_mask (( &__v4sf)  &__A, ( &__v16sf)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcast_f32x2 ( &__mmask16  &__M,  &__m128  &__A) { ( &__m512)  &__builtin_ia32_broadcastf32x2_512_mask (( &__v4sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcast_i32x2 ( &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti32x2_512_mask (( &__v4si)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcast_i32x2 ( &__m512i  &__O,  &__mmask16  &__M,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti32x2_512_mask (( &__v4si)  &__A, ( &__v16si)  &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcast_i32x2 ( &__mmask16  &__M,  &__m128i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti32x2_512_mask (( &__v4si)  &__A, ( &__v16si)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcast_f32x8 ( &__m256  &__A) { ( &__m512)  &__builtin_ia32_broadcastf32x8_512_mask (( &__v8sf)  &__A,  &_mm512_undefined_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcast_f32x8 ( &__m512  &__O,  &__mmask16  &__M,  &__m256  &__A) { ( &__m512)  &__builtin_ia32_broadcastf32x8_512_mask (( &__v8sf)  &__A, ( &__v16sf) &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcast_f32x8 ( &__mmask16  &__M,  &__m256  &__A) { ( &__m512)  &__builtin_ia32_broadcastf32x8_512_mask (( &__v8sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_broadcast_i32x8 ( &__m256i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti32x8_512_mask (( &__v8si)  &__A, ( &__v16si)  &_mm512_undefined_epi32 (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_broadcast_i32x8 ( &__m512i  &__O,  &__mmask16  &__M,  &__m256i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti32x8_512_mask (( &__v8si)  &__A, ( &__v16si) &__O,  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_broadcast_i32x8 ( &__mmask16  &__M,  &__m256i  &__A) { ( &__m512i)  &__builtin_ia32_broadcasti32x8_512_mask (( &__v8si)  &__A, ( &__v16si)  &_mm512_setzero_si512 (),  &__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mullo_epi64 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) (( &__v8du)  &__A * ( &__v8du)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_mullo_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmullq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_mullo_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_pmullq512_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_xor_pd ( &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_xorpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_xor_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_xorpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_xor_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_xorpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_xor_ps ( &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_xorps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_xor_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_xorps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_xor_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_xorps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_or_pd ( &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_orpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_or_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_orpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_or_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_orpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_or_ps ( &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_orps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_or_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_orps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_or_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_orps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_and_pd ( &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_andpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_and_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_andpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_and_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_andpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_and_ps ( &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_andps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_and_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_andps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_and_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_andps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_andnot_pd ( &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_andnpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_andnot_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_andnpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_andnot_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B) { ( &__m512d)  &__builtin_ia32_andnpd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_andnot_ps ( &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_andnps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16) -1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_andnot_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_andnps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_andnot_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B) { ( &__m512)  &__builtin_ia32_andnps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_movepi32_mask ( &__m512i  &__A) { ( &__mmask16)  &__builtin_ia32_cvtd2mask512 (( &__v16si)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_movepi64_mask ( &__m512i  &__A) { ( &__mmask8)  &__builtin_ia32_cvtq2mask512 (( &__v8di)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_movm_epi32 ( &__mmask16  &__A) { ( &__m512i)  &__builtin_ia32_cvtmask2d512 ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_movm_epi64 ( &__mmask8  &__A) { ( &__m512i)  &__builtin_ia32_cvtmask2q512 ( &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvttpd_epi64 ( &__m512d  &__A) { ( &__m512i)  &__builtin_ia32_cvttpd2qq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvttpd_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512i)  &__builtin_ia32_cvttpd2qq512_mask (( &__v8df)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvttpd_epi64 ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m512i)  &__builtin_ia32_cvttpd2qq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvttpd_epu64 ( &__m512d  &__A) { ( &__m512i)  &__builtin_ia32_cvttpd2uqq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvttpd_epu64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512i)  &__builtin_ia32_cvttpd2uqq512_mask (( &__v8df)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvttpd_epu64 ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m512i)  &__builtin_ia32_cvttpd2uqq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvttps_epi64 ( &__m256  &__A) { ( &__m512i)  &__builtin_ia32_cvttps2qq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvttps_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m256  &__A) { ( &__m512i)  &__builtin_ia32_cvttps2qq512_mask (( &__v8sf)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvttps_epi64 ( &__mmask8  &__U,  &__m256  &__A) { ( &__m512i)  &__builtin_ia32_cvttps2qq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvttps_epu64 ( &__m256  &__A) { ( &__m512i)  &__builtin_ia32_cvttps2uqq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvttps_epu64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m256  &__A) { ( &__m512i)  &__builtin_ia32_cvttps2uqq512_mask (( &__v8sf)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvttps_epu64 ( &__mmask8  &__U,  &__m256  &__A) { ( &__m512i)  &__builtin_ia32_cvttps2uqq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtpd_epi64 ( &__m512d  &__A) { ( &__m512i)  &__builtin_ia32_cvtpd2qq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtpd_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512i)  &__builtin_ia32_cvtpd2qq512_mask (( &__v8df)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtpd_epi64 ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m512i)  &__builtin_ia32_cvtpd2qq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtpd_epu64 ( &__m512d  &__A) { ( &__m512i)  &__builtin_ia32_cvtpd2uqq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtpd_epu64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512d  &__A) { ( &__m512i)  &__builtin_ia32_cvtpd2uqq512_mask (( &__v8df)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtpd_epu64 ( &__mmask8  &__U,  &__m512d  &__A) { ( &__m512i)  &__builtin_ia32_cvtpd2uqq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtps_epi64 ( &__m256  &__A) { ( &__m512i)  &__builtin_ia32_cvtps2qq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtps_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m256  &__A) { ( &__m512i)  &__builtin_ia32_cvtps2qq512_mask (( &__v8sf)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtps_epi64 ( &__mmask8  &__U,  &__m256  &__A) { ( &__m512i)  &__builtin_ia32_cvtps2qq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtps_epu64 ( &__m256  &__A) { ( &__m512i)  &__builtin_ia32_cvtps2uqq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtps_epu64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m256  &__A) { ( &__m512i)  &__builtin_ia32_cvtps2uqq512_mask (( &__v8sf)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtps_epu64 ( &__mmask8  &__U,  &__m256  &__A) { ( &__m512i)  &__builtin_ia32_cvtps2uqq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi64_ps ( &__m512i  &__A) { ( &__m256)  &__builtin_ia32_cvtqq2ps512_mask (( &__v8di)  &__A, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi64_ps ( &__m256  &__W,  &__mmask8  &__U,  &__m512i  &__A) { ( &__m256)  &__builtin_ia32_cvtqq2ps512_mask (( &__v8di)  &__A, ( &__v8sf)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi64_ps ( &__mmask8  &__U,  &__m512i  &__A) { ( &__m256)  &__builtin_ia32_cvtqq2ps512_mask (( &__v8di)  &__A, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepu64_ps ( &__m512i  &__A) { ( &__m256)  &__builtin_ia32_cvtuqq2ps512_mask (( &__v8di)  &__A, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepu64_ps ( &__m256  &__W,  &__mmask8  &__U,  &__m512i  &__A) { ( &__m256)  &__builtin_ia32_cvtuqq2ps512_mask (( &__v8di)  &__A, ( &__v8sf)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepu64_ps ( &__mmask8  &__U,  &__m512i  &__A) { ( &__m256)  &__builtin_ia32_cvtuqq2ps512_mask (( &__v8di)  &__A, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepi64_pd ( &__m512i  &__A) { ( &__m512d)  &__builtin_ia32_cvtqq2pd512_mask (( &__v8di)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepi64_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512i  &__A) { ( &__m512d)  &__builtin_ia32_cvtqq2pd512_mask (( &__v8di)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepi64_pd ( &__mmask8  &__U,  &__m512i  &__A) { ( &__m512d)  &__builtin_ia32_cvtqq2pd512_mask (( &__v8di)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtepu64_pd ( &__m512i  &__A) { ( &__m512d)  &__builtin_ia32_cvtuqq2pd512_mask (( &__v8di)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtepu64_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512i  &__A) { ( &__m512d)  &__builtin_ia32_cvtuqq2pd512_mask (( &__v8di)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtepu64_pd ( &__mmask8  &__U,  &__m512i  &__A) { ( &__m512d)  &__builtin_ia32_cvtuqq2pd512_mask (( &__v8di)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kshiftli_mask8 ( &__mmask8  &__A, my $__B) { ( &__mmask8)  &__builtin_ia32_kshiftliqi (( &__mmask8)  &__A, ( &__mmask8)  $__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_kshiftri_mask8 ( &__mmask8  &__A, my $__B) { ( &__mmask8)  &__builtin_ia32_kshiftriqi (( &__mmask8)  &__A, ( &__mmask8)  $__B); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_range_pd ( &__m512d  &__A,  &__m512d  &__B, \'int\'  &__C) { ( &__m512d)  &__builtin_ia32_rangepd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B,  &__C, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_range_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B, \'int\'  &__C) { ( &__m512d)  &__builtin_ia32_rangepd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B,  &__C, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_range_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B, \'int\'  &__C) { ( &__m512d)  &__builtin_ia32_rangepd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B,  &__C, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_range_ps ( &__m512  &__A,  &__m512  &__B, \'int\'  &__C) { ( &__m512)  &__builtin_ia32_rangeps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B,  &__C, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_range_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B, \'int\'  &__C) { ( &__m512)  &__builtin_ia32_rangeps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B,  &__C, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_range_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B, \'int\'  &__C) { ( &__m512)  &__builtin_ia32_rangeps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B,  &__C, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_reduce_sd ( &__m128d  &__A,  &__m128d  &__B, \'int\'  &__C) { ( &__m128d)  &__builtin_ia32_reducesd_mask (( &__v2df)  &__A, ( &__v2df)  &__B,  &__C, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_reduce_sd ( &__m128d  &__W,  &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B, \'int\'  &__C) { ( &__m128d)  &__builtin_ia32_reducesd_mask (( &__v2df)  &__A, ( &__v2df)  &__B,  &__C, ( &__v2df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_reduce_sd ( &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B, \'int\'  &__C) { ( &__m128d)  &__builtin_ia32_reducesd_mask (( &__v2df)  &__A, ( &__v2df)  &__B,  &__C, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_reduce_ss ( &__m128  &__A,  &__m128  &__B, \'int\'  &__C) { ( &__m128)  &__builtin_ia32_reducess_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__C, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_reduce_ss ( &__m128  &__W,  &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B, \'int\'  &__C) { ( &__m128)  &__builtin_ia32_reducess_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__C, ( &__v4sf)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_reduce_ss ( &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B, \'int\'  &__C) { ( &__m128)  &__builtin_ia32_reducess_mask (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__C, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_range_sd ( &__m128d  &__A,  &__m128d  &__B, \'int\'  &__C) { ( &__m128d)  &__builtin_ia32_rangesd128_mask_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__C, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_range_sd ( &__m128d  &__W,  &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B, \'int\'  &__C) { ( &__m128d)  &__builtin_ia32_rangesd128_mask_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__C, ( &__v2df)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_range_sd ( &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B, \'int\'  &__C) { ( &__m128d)  &__builtin_ia32_rangesd128_mask_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__C, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_range_ss ( &__m128  &__A,  &__m128  &__B, \'int\'  &__C) { ( &__m128)  &__builtin_ia32_rangess128_mask_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__C, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_range_ss ( &__m128  &__W,  &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B, \'int\'  &__C) { ( &__m128)  &__builtin_ia32_rangess128_mask_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__C, ( &__v4sf)  &__W, ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_range_ss ( &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B, \'int\'  &__C) { ( &__m128)  &__builtin_ia32_rangess128_mask_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__C, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U,  &_MM_FROUND_CUR_DIRECTION); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_range_round_sd ( &__m128d  &__A,  &__m128d  &__B, \'int\'  &__C,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_rangesd128_mask_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__C, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_range_round_sd ( &__m128d  &__W,  &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B, \'int\'  &__C,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_rangesd128_mask_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__C, ( &__v2df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_range_round_sd ( &__mmask8  &__U,  &__m128d  &__A,  &__m128d  &__B, \'int\'  &__C,  &const \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_rangesd128_mask_round (( &__v2df)  &__A, ( &__v2df)  &__B,  &__C, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_range_round_ss ( &__m128  &__A,  &__m128  &__B, \'int\'  &__C,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_rangess128_mask_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__C, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_range_round_ss ( &__m128  &__W,  &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B, \'int\'  &__C,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_rangess128_mask_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__C, ( &__v4sf)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_maskz_range_round_ss ( &__mmask8  &__U,  &__m128  &__A,  &__m128  &__B, \'int\'  &__C,  &const \'int\'  &__R) { ( &__m128)  &__builtin_ia32_rangess128_mask_round (( &__v4sf)  &__A, ( &__v4sf)  &__B,  &__C, ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fpclass_ss_mask ( &__m128  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclassss_mask (( &__v4sf)  &__A,  &__imm, ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_fpclass_sd_mask ( &__m128d  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclasssd_mask (( &__v2df)  &__A,  &__imm, ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_fpclass_ss_mask ( &__mmask8  &__U,  &__m128  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclassss_mask (( &__v4sf)  &__A,  &__imm,  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mask_fpclass_sd_mask ( &__mmask8  &__U,  &__m128d  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclasssd_mask (( &__v2df)  &__A,  &__imm,  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtt_roundpd_epi64 ( &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttpd2qq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtt_roundpd_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttpd2qq512_mask (( &__v8df)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtt_roundpd_epi64 ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttpd2qq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtt_roundpd_epu64 ( &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttpd2uqq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtt_roundpd_epu64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttpd2uqq512_mask (( &__v8df)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtt_roundpd_epu64 ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttpd2uqq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtt_roundps_epi64 ( &__m256  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttps2qq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtt_roundps_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m256  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttps2qq512_mask (( &__v8sf)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtt_roundps_epi64 ( &__mmask8  &__U,  &__m256  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttps2qq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvtt_roundps_epu64 ( &__m256  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttps2uqq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvtt_roundps_epu64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m256  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttps2uqq512_mask (( &__v8sf)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvtt_roundps_epu64 ( &__mmask8  &__U,  &__m256  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvttps2uqq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundpd_epi64 ( &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtpd2qq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundpd_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtpd2qq512_mask (( &__v8df)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundpd_epi64 ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtpd2qq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundpd_epu64 ( &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtpd2uqq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundpd_epu64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtpd2uqq512_mask (( &__v8df)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundpd_epu64 ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtpd2uqq512_mask (( &__v8df)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundps_epi64 ( &__m256  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtps2qq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundps_epi64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m256  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtps2qq512_mask (( &__v8sf)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundps_epi64 ( &__mmask8  &__U,  &__m256  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtps2qq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundps_epu64 ( &__m256  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtps2uqq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundps_epu64 ( &__m512i  &__W,  &__mmask8  &__U,  &__m256  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtps2uqq512_mask (( &__v8sf)  &__A, ( &__v8di)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundps_epu64 ( &__mmask8  &__U,  &__m256  &__A,  &const \'int\'  &__R) { ( &__m512i)  &__builtin_ia32_cvtps2uqq512_mask (( &__v8sf)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundepi64_ps ( &__m512i  &__A,  &const \'int\'  &__R) { ( &__m256)  &__builtin_ia32_cvtqq2ps512_mask (( &__v8di)  &__A, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundepi64_ps ( &__m256  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__R) { ( &__m256)  &__builtin_ia32_cvtqq2ps512_mask (( &__v8di)  &__A, ( &__v8sf)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundepi64_ps ( &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__R) { ( &__m256)  &__builtin_ia32_cvtqq2ps512_mask (( &__v8di)  &__A, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundepu64_ps ( &__m512i  &__A,  &const \'int\'  &__R) { ( &__m256)  &__builtin_ia32_cvtuqq2ps512_mask (( &__v8di)  &__A, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundepu64_ps ( &__m256  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__R) { ( &__m256)  &__builtin_ia32_cvtuqq2ps512_mask (( &__v8di)  &__A, ( &__v8sf)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundepu64_ps ( &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__R) { ( &__m256)  &__builtin_ia32_cvtuqq2ps512_mask (( &__v8di)  &__A, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundepi64_pd ( &__m512i  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_cvtqq2pd512_mask (( &__v8di)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundepi64_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_cvtqq2pd512_mask (( &__v8di)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundepi64_pd ( &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_cvtqq2pd512_mask (( &__v8di)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_cvt_roundepu64_pd ( &__m512i  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_cvtuqq2pd512_mask (( &__v8di)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_cvt_roundepu64_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_cvtuqq2pd512_mask (( &__v8di)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_cvt_roundepu64_pd ( &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_cvtuqq2pd512_mask (( &__v8di)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_pd ( &__m512d  &__A, \'int\'  &__B) { ( &__m512d)  &__builtin_ia32_reducepd512_mask (( &__v8df)  &__A,  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A, \'int\'  &__B) { ( &__m512d)  &__builtin_ia32_reducepd512_mask (( &__v8df)  &__A,  &__B, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_reduce_pd ( &__mmask8  &__U,  &__m512d  &__A, \'int\'  &__B) { ( &__m512d)  &__builtin_ia32_reducepd512_mask (( &__v8df)  &__A,  &__B, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_reduce_ps ( &__m512  &__A, \'int\'  &__B) { ( &__m512)  &__builtin_ia32_reduceps512_mask (( &__v16sf)  &__A,  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_reduce_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A, \'int\'  &__B) { ( &__m512)  &__builtin_ia32_reduceps512_mask (( &__v16sf)  &__A,  &__B, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_reduce_ps ( &__mmask16  &__U,  &__m512  &__A, \'int\'  &__B) { ( &__m512)  &__builtin_ia32_reduceps512_mask (( &__v16sf)  &__A,  &__B, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_extractf32x8_ps ( &__m512  &__A,  &const \'int\'  &__imm) { ( &__m256)  &__builtin_ia32_extractf32x8_mask (( &__v16sf)  &__A,  &__imm, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_extractf32x8_ps ( &__m256  &__W,  &__mmask8  &__U,  &__m512  &__A,  &const \'int\'  &__imm) { ( &__m256)  &__builtin_ia32_extractf32x8_mask (( &__v16sf)  &__A,  &__imm, ( &__v8sf)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_extractf32x8_ps ( &__mmask8  &__U,  &__m512  &__A,  &const \'int\'  &__imm) { ( &__m256)  &__builtin_ia32_extractf32x8_mask (( &__v16sf)  &__A,  &__imm, ( &__v8sf)  &_mm256_setzero_ps (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_extractf64x2_pd ( &__m512d  &__A,  &const \'int\'  &__imm) { ( &__m128d)  &__builtin_ia32_extractf64x2_512_mask (( &__v8df)  &__A,  &__imm, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_extractf64x2_pd ( &__m128d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__imm) { ( &__m128d)  &__builtin_ia32_extractf64x2_512_mask (( &__v8df)  &__A,  &__imm, ( &__v2df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_extractf64x2_pd ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__imm) { ( &__m128d)  &__builtin_ia32_extractf64x2_512_mask (( &__v8df)  &__A,  &__imm, ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_extracti32x8_epi32 ( &__m512i  &__A,  &const \'int\'  &__imm) { ( &__m256i)  &__builtin_ia32_extracti32x8_mask (( &__v16si)  &__A,  &__imm, ( &__v8si)  &_mm256_setzero_si256 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_extracti32x8_epi32 ( &__m256i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__imm) { ( &__m256i)  &__builtin_ia32_extracti32x8_mask (( &__v16si)  &__A,  &__imm, ( &__v8si)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_extracti32x8_epi32 ( &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__imm) { ( &__m256i)  &__builtin_ia32_extracti32x8_mask (( &__v16si)  &__A,  &__imm, ( &__v8si)  &_mm256_setzero_si256 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_extracti64x2_epi64 ( &__m512i  &__A,  &const \'int\'  &__imm) { ( &__m128i)  &__builtin_ia32_extracti64x2_512_mask (( &__v8di)  &__A,  &__imm, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_extracti64x2_epi64 ( &__m128i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__imm) { ( &__m128i)  &__builtin_ia32_extracti64x2_512_mask (( &__v8di)  &__A,  &__imm, ( &__v2di)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_extracti64x2_epi64 ( &__mmask8  &__U,  &__m512i  &__A,  &const \'int\'  &__imm) { ( &__m128i)  &__builtin_ia32_extracti64x2_512_mask (( &__v8di)  &__A,  &__imm, ( &__v2di)  &_mm_setzero_si128 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_range_round_pd ( &__m512d  &__A,  &__m512d  &__B, \'int\'  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_rangepd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B,  &__C, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_range_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B, \'int\'  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_rangepd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B,  &__C, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_range_round_pd ( &__mmask8  &__U,  &__m512d  &__A,  &__m512d  &__B, \'int\'  &__C,  &const \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_rangepd512_mask (( &__v8df)  &__A, ( &__v8df)  &__B,  &__C, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_range_round_ps ( &__m512  &__A,  &__m512  &__B, \'int\'  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_rangeps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B,  &__C, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_range_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B, \'int\'  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_rangeps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B,  &__C, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_range_round_ps ( &__mmask16  &__U,  &__m512  &__A,  &__m512  &__B, \'int\'  &__C,  &const \'int\'  &__R) { ( &__m512)  &__builtin_ia32_rangeps512_mask (( &__v16sf)  &__A, ( &__v16sf)  &__B,  &__C, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_inserti32x8 ( &__m512i  &__A,  &__m256i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_inserti32x8_mask (( &__v16si)  &__A, ( &__v8si)  &__B,  &__imm, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_inserti32x8 ( &__m512i  &__W,  &__mmask16  &__U,  &__m512i  &__A,  &__m256i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_inserti32x8_mask (( &__v16si)  &__A, ( &__v8si)  &__B,  &__imm, ( &__v16si)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_inserti32x8 ( &__mmask16  &__U,  &__m512i  &__A,  &__m256i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_inserti32x8_mask (( &__v16si)  &__A, ( &__v8si)  &__B,  &__imm, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_insertf32x8 ( &__m512  &__A,  &__m256  &__B,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_insertf32x8_mask (( &__v16sf)  &__A, ( &__v8sf)  &__B,  &__imm, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_insertf32x8 ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A,  &__m256  &__B,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_insertf32x8_mask (( &__v16sf)  &__A, ( &__v8sf)  &__B,  &__imm, ( &__v16sf)  &__W, ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_insertf32x8 ( &__mmask16  &__U,  &__m512  &__A,  &__m256  &__B,  &const \'int\'  &__imm) { ( &__m512)  &__builtin_ia32_insertf32x8_mask (( &__v16sf)  &__A, ( &__v8sf)  &__B,  &__imm, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_inserti64x2 ( &__m512i  &__A,  &__m128i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_inserti64x2_512_mask (( &__v8di)  &__A, ( &__v2di)  &__B,  &__imm, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_inserti64x2 ( &__m512i  &__W,  &__mmask8  &__U,  &__m512i  &__A,  &__m128i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_inserti64x2_512_mask (( &__v8di)  &__A, ( &__v2di)  &__B,  &__imm, ( &__v8di)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_inserti64x2 ( &__mmask8  &__U,  &__m512i  &__A,  &__m128i  &__B,  &const \'int\'  &__imm) { ( &__m512i)  &__builtin_ia32_inserti64x2_512_mask (( &__v8di)  &__A, ( &__v2di)  &__B,  &__imm, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_insertf64x2 ( &__m512d  &__A,  &__m128d  &__B,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_insertf64x2_512_mask (( &__v8df)  &__A, ( &__v2df)  &__B,  &__imm, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_insertf64x2 ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A,  &__m128d  &__B,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_insertf64x2_512_mask (( &__v8df)  &__A, ( &__v2df)  &__B,  &__imm, ( &__v8df)  &__W, ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_insertf64x2 ( &__mmask8  &__U,  &__m512d  &__A,  &__m128d  &__B,  &const \'int\'  &__imm) { ( &__m512d)  &__builtin_ia32_insertf64x2_512_mask (( &__v8df)  &__A, ( &__v2df)  &__B,  &__imm, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fpclass_pd_mask ( &__mmask8  &__U,  &__m512d  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclasspd512_mask (( &__v8df)  &__A,  &__imm,  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fpclass_pd_mask ( &__m512d  &__A,  &const \'int\'  &__imm) { ( &__mmask8)  &__builtin_ia32_fpclasspd512_mask (( &__v8df)  &__A,  &__imm, ( &__mmask8) -1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_fpclass_ps_mask ( &__mmask16  &__U,  &__m512  &__A,  &const \'int\'  &__imm) { ( &__mmask16)  &__builtin_ia32_fpclassps512_mask (( &__v16sf)  &__A,  &__imm,  &__U); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_fpclass_ps_mask ( &__m512  &__A,  &const \'int\'  &__imm) { ( &__mmask16)  &__builtin_ia32_fpclassps512_mask (( &__v16sf)  &__A,  &__imm, ( &__mmask16) -1); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _kshiftli_mask8 {
	    my($X, $Y) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_kshiftliqi (( &__mmask8)($X), ( &__mmask8)($Y))));
	}' unless defined(&_kshiftli_mask8);
	eval 'sub _kshiftri_mask8 {
	    my($X, $Y) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_kshiftriqi (( &__mmask8)($X), ( &__mmask8)($Y))));
	}' unless defined(&_kshiftri_mask8);
	eval 'sub _mm_range_sd {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_rangesd128_mask_round (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C), ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_range_sd);
	eval 'sub _mm_mask_range_sd {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_rangesd128_mask_round (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C), ( &__v2df)( &__m128d)($W), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_mask_range_sd);
	eval 'sub _mm_maskz_range_sd {
	    my($U, $A, $B, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_rangesd128_mask_round (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C), ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_maskz_range_sd);
	eval 'sub _mm_range_ss {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_rangess128_mask_round (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C), ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8) -1,  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_range_ss);
	eval 'sub _mm_mask_range_ss {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_rangess128_mask_round (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C), ( &__v4sf)( &__m128)($W), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_mask_range_ss);
	eval 'sub _mm_maskz_range_ss {
	    my($U, $A, $B, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_rangess128_mask_round (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C), ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm_maskz_range_ss);
	eval 'sub _mm_range_round_sd {
	    my($A, $B, $C, $R) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_rangesd128_mask_round (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C), ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8) -1, ($R))));
	}' unless defined(&_mm_range_round_sd);
	eval 'sub _mm_mask_range_round_sd {
	    my($W, $U, $A, $B, $C, $R) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_rangesd128_mask_round (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C), ( &__v2df)( &__m128d)($W), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm_mask_range_round_sd);
	eval 'sub _mm_maskz_range_round_sd {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_rangesd128_mask_round (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C), ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm_maskz_range_round_sd);
	eval 'sub _mm_range_round_ss {
	    my($A, $B, $C, $R) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_rangess128_mask_round (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C), ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8) -1, ($R))));
	}' unless defined(&_mm_range_round_ss);
	eval 'sub _mm_mask_range_round_ss {
	    my($W, $U, $A, $B, $C, $R) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_rangess128_mask_round (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C), ( &__v4sf)( &__m128)($W), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm_mask_range_round_ss);
	eval 'sub _mm_maskz_range_round_ss {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_rangess128_mask_round (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C), ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm_maskz_range_round_ss);
	eval 'sub _mm512_cvtt_roundpd_epi64 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttpd2qq512_mask (($A), ( &__v8di)  &_mm512_setzero_si512 (), -1, ($B))));
	}' unless defined(&_mm512_cvtt_roundpd_epi64);
	eval 'sub _mm512_mask_cvtt_roundpd_epi64 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttpd2qq512_mask (($A), ( &__v8di)($W), ($U), ($B))));
	}' unless defined(&_mm512_mask_cvtt_roundpd_epi64);
	eval 'sub _mm512_maskz_cvtt_roundpd_epi64 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttpd2qq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), ($U), ($B))));
	}' unless defined(&_mm512_maskz_cvtt_roundpd_epi64);
	eval 'sub _mm512_cvtt_roundpd_epu64 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttpd2uqq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), -1, ($B))));
	}' unless defined(&_mm512_cvtt_roundpd_epu64);
	eval 'sub _mm512_mask_cvtt_roundpd_epu64 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttpd2uqq512_mask (($A), ( &__v8di)($W), ($U), ($B))));
	}' unless defined(&_mm512_mask_cvtt_roundpd_epu64);
	eval 'sub _mm512_maskz_cvtt_roundpd_epu64 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttpd2uqq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), ($U), ($B))));
	}' unless defined(&_mm512_maskz_cvtt_roundpd_epu64);
	eval 'sub _mm512_cvtt_roundps_epi64 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttps2qq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), -1, ($B))));
	}' unless defined(&_mm512_cvtt_roundps_epi64);
	eval 'sub _mm512_mask_cvtt_roundps_epi64 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttps2qq512_mask (($A), ( &__v8di)($W), ($U), ($B))));
	}' unless defined(&_mm512_mask_cvtt_roundps_epi64);
	eval 'sub _mm512_maskz_cvtt_roundps_epi64 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttps2qq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), ($U), ($B))));
	}' unless defined(&_mm512_maskz_cvtt_roundps_epi64);
	eval 'sub _mm512_cvtt_roundps_epu64 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttps2uqq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), -1, ($B))));
	}' unless defined(&_mm512_cvtt_roundps_epu64);
	eval 'sub _mm512_mask_cvtt_roundps_epu64 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttps2uqq512_mask (($A), ( &__v8di)($W), ($U), ($B))));
	}' unless defined(&_mm512_mask_cvtt_roundps_epu64);
	eval 'sub _mm512_maskz_cvtt_roundps_epu64 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvttps2uqq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), ($U), ($B))));
	}' unless defined(&_mm512_maskz_cvtt_roundps_epu64);
	eval 'sub _mm512_cvt_roundpd_epi64 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtpd2qq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), -1, ($B))));
	}' unless defined(&_mm512_cvt_roundpd_epi64);
	eval 'sub _mm512_mask_cvt_roundpd_epi64 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtpd2qq512_mask (($A), ( &__v8di)($W), ($U), ($B))));
	}' unless defined(&_mm512_mask_cvt_roundpd_epi64);
	eval 'sub _mm512_maskz_cvt_roundpd_epi64 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtpd2qq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), ($U), ($B))));
	}' unless defined(&_mm512_maskz_cvt_roundpd_epi64);
	eval 'sub _mm512_cvt_roundpd_epu64 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtpd2uqq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), -1, ($B))));
	}' unless defined(&_mm512_cvt_roundpd_epu64);
	eval 'sub _mm512_mask_cvt_roundpd_epu64 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtpd2uqq512_mask (($A), ( &__v8di)($W), ($U), ($B))));
	}' unless defined(&_mm512_mask_cvt_roundpd_epu64);
	eval 'sub _mm512_maskz_cvt_roundpd_epu64 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtpd2uqq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), ($U), ($B))));
	}' unless defined(&_mm512_maskz_cvt_roundpd_epu64);
	eval 'sub _mm512_cvt_roundps_epi64 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtps2qq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), -1, ($B))));
	}' unless defined(&_mm512_cvt_roundps_epi64);
	eval 'sub _mm512_mask_cvt_roundps_epi64 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtps2qq512_mask (($A), ( &__v8di)($W), ($U), ($B))));
	}' unless defined(&_mm512_mask_cvt_roundps_epi64);
	eval 'sub _mm512_maskz_cvt_roundps_epi64 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtps2qq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), ($U), ($B))));
	}' unless defined(&_mm512_maskz_cvt_roundps_epi64);
	eval 'sub _mm512_cvt_roundps_epu64 {
	    my($A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtps2uqq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), -1, ($B))));
	}' unless defined(&_mm512_cvt_roundps_epu64);
	eval 'sub _mm512_mask_cvt_roundps_epu64 {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtps2uqq512_mask (($A), ( &__v8di)($W), ($U), ($B))));
	}' unless defined(&_mm512_mask_cvt_roundps_epu64);
	eval 'sub _mm512_maskz_cvt_roundps_epu64 {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512i) &__builtin_ia32_cvtps2uqq512_mask (($A), ( &__v8di) &_mm512_setzero_si512 (), ($U), ($B))));
	}' unless defined(&_mm512_maskz_cvt_roundps_epu64);
	eval 'sub _mm512_cvt_roundepi64_ps {
	    my($A, $B) = @_;
    	    eval q((( &__m256) &__builtin_ia32_cvtqq2ps512_mask (( &__v8di)($A), ( &__v8sf) &_mm256_setzero_ps (), -1, ($B))));
	}' unless defined(&_mm512_cvt_roundepi64_ps);
	eval 'sub _mm512_mask_cvt_roundepi64_ps {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m256) &__builtin_ia32_cvtqq2ps512_mask (( &__v8di)($A), ($W), ($U), ($B))));
	}' unless defined(&_mm512_mask_cvt_roundepi64_ps);
	eval 'sub _mm512_maskz_cvt_roundepi64_ps {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m256) &__builtin_ia32_cvtqq2ps512_mask (( &__v8di)($A), ( &__v8sf) &_mm256_setzero_ps (), ($U), ($B))));
	}' unless defined(&_mm512_maskz_cvt_roundepi64_ps);
	eval 'sub _mm512_cvt_roundepu64_ps {
	    my($A, $B) = @_;
    	    eval q((( &__m256) &__builtin_ia32_cvtuqq2ps512_mask (( &__v8di)($A), ( &__v8sf) &_mm256_setzero_ps (), -1, ($B))));
	}' unless defined(&_mm512_cvt_roundepu64_ps);
	eval 'sub _mm512_mask_cvt_roundepu64_ps {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m256) &__builtin_ia32_cvtuqq2ps512_mask (( &__v8di)($A), ($W), ($U), ($B))));
	}' unless defined(&_mm512_mask_cvt_roundepu64_ps);
	eval 'sub _mm512_maskz_cvt_roundepu64_ps {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m256) &__builtin_ia32_cvtuqq2ps512_mask (( &__v8di)($A), ( &__v8sf) &_mm256_setzero_ps (), ($U), ($B))));
	}' unless defined(&_mm512_maskz_cvt_roundepu64_ps);
	eval 'sub _mm512_cvt_roundepi64_pd {
	    my($A, $B) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_cvtqq2pd512_mask (( &__v8di)($A), ( &__v8df) &_mm512_setzero_pd (), -1, ($B))));
	}' unless defined(&_mm512_cvt_roundepi64_pd);
	eval 'sub _mm512_mask_cvt_roundepi64_pd {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_cvtqq2pd512_mask (( &__v8di)($A), ($W), ($U), ($B))));
	}' unless defined(&_mm512_mask_cvt_roundepi64_pd);
	eval 'sub _mm512_maskz_cvt_roundepi64_pd {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_cvtqq2pd512_mask (( &__v8di)($A), ( &__v8df) &_mm512_setzero_pd (), ($U), ($B))));
	}' unless defined(&_mm512_maskz_cvt_roundepi64_pd);
	eval 'sub _mm512_cvt_roundepu64_pd {
	    my($A, $B) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_cvtuqq2pd512_mask (( &__v8di)($A), ( &__v8df) &_mm512_setzero_pd (), -1, ($B))));
	}' unless defined(&_mm512_cvt_roundepu64_pd);
	eval 'sub _mm512_mask_cvt_roundepu64_pd {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_cvtuqq2pd512_mask (( &__v8di)($A), ($W), ($U), ($B))));
	}' unless defined(&_mm512_mask_cvt_roundepu64_pd);
	eval 'sub _mm512_maskz_cvt_roundepu64_pd {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512d) &__builtin_ia32_cvtuqq2pd512_mask (( &__v8di)($A), ( &__v8df) &_mm512_setzero_pd (), ($U), ($B))));
	}' unless defined(&_mm512_maskz_cvt_roundepu64_pd);
	eval 'sub _mm512_reduce_pd {
	    my($A, $B) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_reducepd512_mask (( &__v8df)( &__m512d), ($B), ( &__v8df) &_mm512_setzero_pd (), ( &__mmask8)-1)));
	}' unless defined(&_mm512_reduce_pd);
	eval 'sub _mm512_mask_reduce_pd {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_reducepd512_mask (( &__v8df)( &__m512d), ($B), ( &__v8df)( &__m512d)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm512_mask_reduce_pd);
	eval 'sub _mm512_maskz_reduce_pd {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_reducepd512_mask (( &__v8df)( &__m512d), ($B), ( &__v8df) &_mm512_setzero_pd (), ( &__mmask8)($U))));
	}' unless defined(&_mm512_maskz_reduce_pd);
	eval 'sub _mm512_reduce_ps {
	    my($A, $B) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_reduceps512_mask (( &__v16sf)( &__m512), ($B), ( &__v16sf) &_mm512_setzero_ps (), ( &__mmask16)-1)));
	}' unless defined(&_mm512_reduce_ps);
	eval 'sub _mm512_mask_reduce_ps {
	    my($W, $U, $A, $B) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_reduceps512_mask (( &__v16sf)( &__m512), ($B), ( &__v16sf)( &__m512)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_reduce_ps);
	eval 'sub _mm512_maskz_reduce_ps {
	    my($U, $A, $B) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_reduceps512_mask (( &__v16sf)( &__m512), ($B), ( &__v16sf) &_mm512_setzero_ps (), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_reduce_ps);
	eval 'sub _mm512_extractf32x8_ps {
	    my($X, $C) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_extractf32x8_mask (( &__v16sf)( &__m512) , ($C), ( &__v8sf)( &__m256)  &_mm256_setzero_ps (), ( &__mmask8)-1)));
	}' unless defined(&_mm512_extractf32x8_ps);
	eval 'sub _mm512_mask_extractf32x8_ps {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_extractf32x8_mask (( &__v16sf)( &__m512) , ($C), ( &__v8sf)( &__m256) ($W), ( &__mmask8) ($U))));
	}' unless defined(&_mm512_mask_extractf32x8_ps);
	eval 'sub _mm512_maskz_extractf32x8_ps {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m256)  &__builtin_ia32_extractf32x8_mask (( &__v16sf)( &__m512) , ($C), ( &__v8sf)( &__m256)  &_mm256_setzero_ps (), ( &__mmask8) ($U))));
	}' unless defined(&_mm512_maskz_extractf32x8_ps);
	eval 'sub _mm512_extractf64x2_pd {
	    my($X, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_extractf64x2_512_mask (( &__v8df)( &__m512d) , ($C), ( &__v2df)( &__m128d)  &_mm_setzero_pd (), ( &__mmask8)-1)));
	}' unless defined(&_mm512_extractf64x2_pd);
	eval 'sub _mm512_mask_extractf64x2_pd {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_extractf64x2_512_mask (( &__v8df)( &__m512d) , ($C), ( &__v2df)( &__m128d) ($W), ( &__mmask8) ($U))));
	}' unless defined(&_mm512_mask_extractf64x2_pd);
	eval 'sub _mm512_maskz_extractf64x2_pd {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_extractf64x2_512_mask (( &__v8df)( &__m512d) , ($C), ( &__v2df)( &__m128d)  &_mm_setzero_pd (), ( &__mmask8) ($U))));
	}' unless defined(&_mm512_maskz_extractf64x2_pd);
	eval 'sub _mm512_extracti32x8_epi32 {
	    my($X, $C) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_extracti32x8_mask (( &__v16si)( &__m512i) , ($C), ( &__v8si)( &__m256i)  &_mm256_setzero_si256 (), ( &__mmask8)-1)));
	}' unless defined(&_mm512_extracti32x8_epi32);
	eval 'sub _mm512_mask_extracti32x8_epi32 {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_extracti32x8_mask (( &__v16si)( &__m512i) , ($C), ( &__v8si)( &__m256i) ($W), ( &__mmask8) ($U))));
	}' unless defined(&_mm512_mask_extracti32x8_epi32);
	eval 'sub _mm512_maskz_extracti32x8_epi32 {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m256i)  &__builtin_ia32_extracti32x8_mask (( &__v16si)( &__m512i) , ($C), ( &__v8si)( &__m256i)  &_mm256_setzero_si256 (), ( &__mmask8) ($U))));
	}' unless defined(&_mm512_maskz_extracti32x8_epi32);
	eval 'sub _mm512_extracti64x2_epi64 {
	    my($X, $C) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_extracti64x2_512_mask (( &__v8di)( &__m512i) , ($C), ( &__v2di)( &__m128i)  &_mm_setzero_si128 (), ( &__mmask8)-1)));
	}' unless defined(&_mm512_extracti64x2_epi64);
	eval 'sub _mm512_mask_extracti64x2_epi64 {
	    my($W, $U, $X, $C) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_extracti64x2_512_mask (( &__v8di)( &__m512i) , ($C), ( &__v2di)( &__m128i) ($W), ( &__mmask8) ($U))));
	}' unless defined(&_mm512_mask_extracti64x2_epi64);
	eval 'sub _mm512_maskz_extracti64x2_epi64 {
	    my($U, $X, $C) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_extracti64x2_512_mask (( &__v8di)( &__m512i) , ($C), ( &__v2di)( &__m128i)  &_mm_setzero_si128 (), ( &__mmask8) ($U))));
	}' unless defined(&_mm512_maskz_extracti64x2_epi64);
	eval 'sub _mm512_range_pd {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_rangepd512_mask (( &__v8df)( &__m512d)($A), ( &__v8df)( &__m512d), ($C), ( &__v8df) &_mm512_setzero_pd (), ( &__mmask8)-1,  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_range_pd);
	eval 'sub _mm512_mask_range_pd {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_rangepd512_mask (( &__v8df)( &__m512d)($A), ( &__v8df)( &__m512d), ($C), ( &__v8df)( &__m512d)($W), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_mask_range_pd);
	eval 'sub _mm512_maskz_range_pd {
	    my($U, $A, $B, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_rangepd512_mask (( &__v8df)( &__m512d)($A), ( &__v8df)( &__m512d), ($C), ( &__v8df) &_mm512_setzero_pd (), ( &__mmask8)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_maskz_range_pd);
	eval 'sub _mm512_range_ps {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_rangeps512_mask (( &__v16sf)( &__m512)($A), ( &__v16sf)( &__m512), ($C), ( &__v16sf) &_mm512_setzero_ps (), ( &__mmask16)-1,  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_range_ps);
	eval 'sub _mm512_mask_range_ps {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_rangeps512_mask (( &__v16sf)( &__m512)($A), ( &__v16sf)( &__m512), ($C), ( &__v16sf)( &__m512)($W), ( &__mmask16)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_mask_range_ps);
	eval 'sub _mm512_maskz_range_ps {
	    my($U, $A, $B, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_rangeps512_mask (( &__v16sf)( &__m512)($A), ( &__v16sf)( &__m512), ($C), ( &__v16sf) &_mm512_setzero_ps (), ( &__mmask16)($U),  &_MM_FROUND_CUR_DIRECTION)));
	}' unless defined(&_mm512_maskz_range_ps);
	eval 'sub _mm512_range_round_pd {
	    my($A, $B, $C, $R) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_rangepd512_mask (( &__v8df)( &__m512d)($A), ( &__v8df)( &__m512d), ($C), ( &__v8df) &_mm512_setzero_pd (), ( &__mmask8)-1, ($R))));
	}' unless defined(&_mm512_range_round_pd);
	eval 'sub _mm512_mask_range_round_pd {
	    my($W, $U, $A, $B, $C, $R) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_rangepd512_mask (( &__v8df)( &__m512d)($A), ( &__v8df)( &__m512d), ($C), ( &__v8df)( &__m512d)($W), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm512_mask_range_round_pd);
	eval 'sub _mm512_maskz_range_round_pd {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_rangepd512_mask (( &__v8df)( &__m512d)($A), ( &__v8df)( &__m512d), ($C), ( &__v8df) &_mm512_setzero_pd (), ( &__mmask8)($U), ($R))));
	}' unless defined(&_mm512_maskz_range_round_pd);
	eval 'sub _mm512_range_round_ps {
	    my($A, $B, $C, $R) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_rangeps512_mask (( &__v16sf)( &__m512)($A), ( &__v16sf)( &__m512), ($C), ( &__v16sf) &_mm512_setzero_ps (), ( &__mmask16)-1, ($R))));
	}' unless defined(&_mm512_range_round_ps);
	eval 'sub _mm512_mask_range_round_ps {
	    my($W, $U, $A, $B, $C, $R) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_rangeps512_mask (( &__v16sf)( &__m512)($A), ( &__v16sf)( &__m512), ($C), ( &__v16sf)( &__m512)($W), ( &__mmask16)($U), ($R))));
	}' unless defined(&_mm512_mask_range_round_ps);
	eval 'sub _mm512_maskz_range_round_ps {
	    my($U, $A, $B, $C, $R) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_rangeps512_mask (( &__v16sf)( &__m512)($A), ( &__v16sf)( &__m512), ($C), ( &__v16sf) &_mm512_setzero_ps (), ( &__mmask16)($U), ($R))));
	}' unless defined(&_mm512_maskz_range_round_ps);
	eval 'sub _mm512_insertf64x2 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_insertf64x2_512_mask (( &__v8df)( &__m512d) ($X), ( &__v2df)( &__m128d) , ($C), ( &__v8df)( &__m512d) ($X), ( &__mmask8)-1)));
	}' unless defined(&_mm512_insertf64x2);
	eval 'sub _mm512_mask_insertf64x2 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_insertf64x2_512_mask (( &__v8df)( &__m512d) ($X), ( &__v2df)( &__m128d) , ($C), ( &__v8df)( &__m512d) ($W), ( &__mmask8) ($U))));
	}' unless defined(&_mm512_mask_insertf64x2);
	eval 'sub _mm512_maskz_insertf64x2 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512d)  &__builtin_ia32_insertf64x2_512_mask (( &__v8df)( &__m512d) ($X), ( &__v2df)( &__m128d) , ($C), ( &__v8df)( &__m512d)  &_mm512_setzero_pd (), ( &__mmask8) ($U))));
	}' unless defined(&_mm512_maskz_insertf64x2);
	eval 'sub _mm512_inserti64x2 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_inserti64x2_512_mask (( &__v8di)( &__m512i) ($X), ( &__v2di)( &__m128i) , ($C), ( &__v8di)( &__m512i) ($X), ( &__mmask8)-1)));
	}' unless defined(&_mm512_inserti64x2);
	eval 'sub _mm512_mask_inserti64x2 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_inserti64x2_512_mask (( &__v8di)( &__m512i) ($X), ( &__v2di)( &__m128i) , ($C), ( &__v8di)( &__m512i) ($W), ( &__mmask8) ($U))));
	}' unless defined(&_mm512_mask_inserti64x2);
	eval 'sub _mm512_maskz_inserti64x2 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_inserti64x2_512_mask (( &__v8di)( &__m512i) ($X), ( &__v2di)( &__m128i) , ($C), ( &__v8di)( &__m512i)  &_mm512_setzero_si512 (), ( &__mmask8) ($U))));
	}' unless defined(&_mm512_maskz_inserti64x2);
	eval 'sub _mm512_insertf32x8 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_insertf32x8_mask (( &__v16sf)( &__m512) ($X), ( &__v8sf)( &__m256) , ($C), ( &__v16sf)( &__m512) &_mm512_setzero_ps (), ( &__mmask16)-1)));
	}' unless defined(&_mm512_insertf32x8);
	eval 'sub _mm512_mask_insertf32x8 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_insertf32x8_mask (( &__v16sf)( &__m512) ($X), ( &__v8sf)( &__m256) , ($C), ( &__v16sf)( &__m512)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_insertf32x8);
	eval 'sub _mm512_maskz_insertf32x8 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512)  &__builtin_ia32_insertf32x8_mask (( &__v16sf)( &__m512) ($X), ( &__v8sf)( &__m256) , ($C), ( &__v16sf)( &__m512) &_mm512_setzero_ps (), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_insertf32x8);
	eval 'sub _mm512_inserti32x8 {
	    my($X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_inserti32x8_mask (( &__v16si)( &__m512i) ($X), ( &__v8si)( &__m256i) , ($C), ( &__v16si)( &__m512i) &_mm512_setzero_si512 (), ( &__mmask16)-1)));
	}' unless defined(&_mm512_inserti32x8);
	eval 'sub _mm512_mask_inserti32x8 {
	    my($W, $U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_inserti32x8_mask (( &__v16si)( &__m512i) ($X), ( &__v8si)( &__m256i) , ($C), ( &__v16si)( &__m512i)($W), ( &__mmask16)($U))));
	}' unless defined(&_mm512_mask_inserti32x8);
	eval 'sub _mm512_maskz_inserti32x8 {
	    my($U, $X, $Y, $C) = @_;
    	    eval q((( &__m512i)  &__builtin_ia32_inserti32x8_mask (( &__v16si)( &__m512i) ($X), ( &__v8si)( &__m256i) , ($C), ( &__v16si)( &__m512i) &_mm512_setzero_si512 (), ( &__mmask16)($U))));
	}' unless defined(&_mm512_maskz_inserti32x8);
	eval 'sub _mm_fpclass_ss_mask {
	    my($X, $C) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclassss_mask (( &__v4sf) ( &__m128) , ($C), ( &__mmask8) (-1))));
	}' unless defined(&_mm_fpclass_ss_mask);
	eval 'sub _mm_fpclass_sd_mask {
	    my($X, $C) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclasssd_mask (( &__v2df) ( &__m128d) , ($C), ( &__mmask8) (-1))));
	}' unless defined(&_mm_fpclass_sd_mask);
	eval 'sub _mm_mask_fpclass_ss_mask {
	    my($X, $C, $U) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclassss_mask (( &__v4sf) ( &__m128) , ($C), ( &__mmask8) ($U))));
	}' unless defined(&_mm_mask_fpclass_ss_mask);
	eval 'sub _mm_mask_fpclass_sd_mask {
	    my($X, $C, $U) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclasssd_mask (( &__v2df) ( &__m128d) , ($C), ( &__mmask8) ($U))));
	}' unless defined(&_mm_mask_fpclass_sd_mask);
	eval 'sub _mm512_mask_fpclass_pd_mask {
	    my($u, $X, $C) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclasspd512_mask (( &__v8df) ( &__m512d) , ($C), ( &__mmask8)($u))));
	}' unless defined(&_mm512_mask_fpclass_pd_mask);
	eval 'sub _mm512_mask_fpclass_ps_mask {
	    my($u, $x, $c) = @_;
    	    eval q((( &__mmask16)  &__builtin_ia32_fpclassps512_mask (( &__v16sf) ( &__m512) , ($c),( &__mmask16)($u))));
	}' unless defined(&_mm512_mask_fpclass_ps_mask);
	eval 'sub _mm512_fpclass_pd_mask {
	    my($X, $C) = @_;
    	    eval q((( &__mmask8)  &__builtin_ia32_fpclasspd512_mask (( &__v8df) ( &__m512d) , ($C), ( &__mmask8)-1)));
	}' unless defined(&_mm512_fpclass_pd_mask);
	eval 'sub _mm512_fpclass_ps_mask {
	    my($x, $c) = @_;
    	    eval q((( &__mmask16)  &__builtin_ia32_fpclassps512_mask (( &__v16sf) ( &__m512) , ($c),( &__mmask16)-1)));
	}' unless defined(&_mm512_fpclass_ps_mask);
	eval 'sub _mm_reduce_sd {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_reducesd_mask (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C), ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)-1)));
	}' unless defined(&_mm_reduce_sd);
	eval 'sub _mm_mask_reduce_sd {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_reducesd_mask (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C), ( &__v2df)( &__m128d)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm_mask_reduce_sd);
	eval 'sub _mm_maskz_reduce_sd {
	    my($U, $A, $B, $C) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_reducesd_mask (( &__v2df)( &__m128d)($A), ( &__v2df)( &__m128d), ($C), ( &__v2df)  &_mm_setzero_pd (), ( &__mmask8)($U))));
	}' unless defined(&_mm_maskz_reduce_sd);
	eval 'sub _mm_reduce_ss {
	    my($A, $B, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_reducess_mask (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C), ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)-1)));
	}' unless defined(&_mm_reduce_ss);
	eval 'sub _mm_mask_reduce_ss {
	    my($W, $U, $A, $B, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_reducess_mask (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C), ( &__v4sf)( &__m128)($W), ( &__mmask8)($U))));
	}' unless defined(&_mm_mask_reduce_ss);
	eval 'sub _mm_maskz_reduce_ss {
	    my($U, $A, $B, $C) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_reducess_mask (( &__v4sf)( &__m128)($A), ( &__v4sf)( &__m128), ($C), ( &__v4sf)  &_mm_setzero_ps (), ( &__mmask8)($U))));
	}' unless defined(&_mm_maskz_reduce_ss);
    }
    if(defined(&__DISABLE_AVX512DQ__)) {
	undef(&__DISABLE_AVX512DQ__) if defined(&__DISABLE_AVX512DQ__);
    }
}
1;
