require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512vp2intersectintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512VP2INTERSECTINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512VP2INTERSECTINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512VP2INTERSECTINTRIN_H_INCLUDED);
    if(!defined(&__AVX512VP2INTERSECT__)) {
	eval 'sub __DISABLE_AVX512VP2INTERSECT__ () {1;}' unless defined(&__DISABLE_AVX512VP2INTERSECT__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_2intersect_epi32 ( &__m512i  &__A,  &__m512i  &__B,  &__mmask16 * &__U,  &__mmask16 * &__M) {  &__builtin_ia32_2intersectd512 ( &__U,  &__M, ( &__v16si)  &__A, ( &__v16si)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_2intersect_epi64 ( &__m512i  &__A,  &__m512i  &__B,  &__mmask8 * &__U,  &__mmask8 * &__M) {  &__builtin_ia32_2intersectq512 ( &__U,  &__M, ( &__v8di)  &__A, ( &__v8di)  &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_AVX512VP2INTERSECT__)) {
	undef(&__DISABLE_AVX512VP2INTERSECT__) if defined(&__DISABLE_AVX512VP2INTERSECT__);
    }
}
1;
