require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_X86INTRIN_H_INCLUDED)  && !defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <bmiintrin.h> directly; include <x86intrin.h> instead.");
}
unless(defined(&_BMIINTRIN_H_INCLUDED)) {
    eval 'sub _BMIINTRIN_H_INCLUDED () {1;}' unless defined(&_BMIINTRIN_H_INCLUDED);
    unless(defined(&__BMI__)) {
	eval 'sub __DISABLE_BMI__ () {1;}' unless defined(&__DISABLE_BMI__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__tzcnt_u16  {  &__builtin_ia32_tzcnt_u16 ( &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__andn_u32 (my $__X, my $__Y) { ~ $__X &  $__Y; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__bextr_u32 (my $__X, my $__Y) {  &__builtin_ia32_bextr_u32 ( $__X,  $__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_bextr_u32 (my $__X, my $__Y, my $__Z) {  &__builtin_ia32_bextr_u32 ( $__X, (( $__Y & 0xff) | (( $__Z & 0xff) << 8))); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blsi_u32  {  &__X & - &__X; });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_blsi_u32  {  &__blsi_u32 ( &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blsmsk_u32  {  &__X ^ ( &__X - 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_blsmsk_u32  {  &__blsmsk_u32 ( &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blsr_u32  {  &__X & ( &__X - 1); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_blsr_u32  {  &__blsr_u32 ( &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__tzcnt_u32  {  &__builtin_ia32_tzcnt_u32 ( &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_tzcnt_u32  {  &__builtin_ia32_tzcnt_u32 ( &__X); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__andn_u64 (my $__X, my $__Y) { ~ $__X &  $__Y; });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__bextr_u64 (my $__X, my $__Y) {  &__builtin_ia32_bextr_u64 ( $__X,  $__Y); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_bextr_u64 (my $__X, my $__Y, my $__Z) {  &__builtin_ia32_bextr_u64 ( $__X, (( $__Y & 0xff) | (( $__Z & 0xff) << 8))); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blsi_u64  {  &__X & - &__X; });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_blsi_u64  {  &__blsi_u64 ( &__X); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blsmsk_u64  {  &__X ^ ( &__X - 1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_blsmsk_u64  {  &__blsmsk_u64 ( &__X); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__blsr_u64  {  &__X & ( &__X - 1); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_blsr_u64  {  &__blsr_u64 ( &__X); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__tzcnt_u64  {  &__builtin_ia32_tzcnt_u64 ( &__X); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_tzcnt_u64  {  &__builtin_ia32_tzcnt_u64 ( &__X); });
	}' unless defined(&__attribute__);
    }
    if(defined(&__DISABLE_BMI__)) {
	undef(&__DISABLE_BMI__) if defined(&__DISABLE_BMI__);
    }
}
1;
