require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <cetintrin.h> directly; include <x86intrin.h> instead.");
}
unless(defined(&_CETINTRIN_H_INCLUDED)) {
    eval 'sub _CETINTRIN_H_INCLUDED () {1;}' unless defined(&_CETINTRIN_H_INCLUDED);
    unless(defined(&__SHSTK__)) {
	eval 'sub __DISABLE_SHSTK__ () {1;}' unless defined(&__DISABLE_SHSTK__);
    }
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_get_ssp ( &void) {  &__builtin_ia32_rdsspq (); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_get_ssp ( &void) {  &__builtin_ia32_rdsspd (); });
	}' unless defined(&__attribute__);
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_inc_ssp  { });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_saveprevssp ( &void) {  &__builtin_ia32_saveprevssp (); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_rstorssp ( &void * &__B) {  &__builtin_ia32_rstorssp ( &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_wrssd (my $__B,  &void * &__C) {  &__builtin_ia32_wrssd ( $__B,  &__C); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_wrssq (my $__B,  &void * &__C) {  &__builtin_ia32_wrssq ( $__B,  &__C); });
	}' unless defined(&__attribute__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_wrussd (my $__B,  &void * &__C) {  &__builtin_ia32_wrussd ( $__B,  &__C); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_wrussq (my $__B,  &void * &__C) {  &__builtin_ia32_wrussq ( $__B,  &__C); });
	}' unless defined(&__attribute__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_setssbsy ( &void) {  &__builtin_ia32_setssbsy (); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_clrssbsy ( &void * &__B) {  &__builtin_ia32_clrssbsy ( &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_SHSTK__)) {
	undef(&__DISABLE_SHSTK__) if defined(&__DISABLE_SHSTK__);
    }
}
1;
