require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_X86INTRIN_H_INCLUDED)  && !defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <lzcntintrin.h> directly; include <x86intrin.h> instead.");
}
unless(defined(&_LZCNTINTRIN_H_INCLUDED)) {
    eval 'sub _LZCNTINTRIN_H_INCLUDED () {1;}' unless defined(&_LZCNTINTRIN_H_INCLUDED);
    unless(defined(&__LZCNT__)) {
	eval 'sub __DISABLE_LZCNT__ () {1;}' unless defined(&__DISABLE_LZCNT__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__lzcnt16  {  &__builtin_ia32_lzcnt_u16 ( &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__lzcnt32  {  &__builtin_ia32_lzcnt_u32 ( &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_lzcnt_u32  {  &__builtin_ia32_lzcnt_u32 ( &__X); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__lzcnt64  {  &__builtin_ia32_lzcnt_u64 ( &__X); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_lzcnt_u64  {  &__builtin_ia32_lzcnt_u64 ( &__X); });
	}' unless defined(&__attribute__);
    }
    if(defined(&__DISABLE_LZCNT__)) {
	undef(&__DISABLE_LZCNT__) if defined(&__DISABLE_LZCNT__);
    }
}
1;
