require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SMMINTRIN_H_INCLUDED)) {
    eval 'sub _SMMINTRIN_H_INCLUDED () {1;}' unless defined(&_SMMINTRIN_H_INCLUDED);
    require 'tmmintrin.ph';
    unless(defined(&__SSE4_1__)) {
	eval 'sub __DISABLE_SSE4_1__ () {1;}' unless defined(&__DISABLE_SSE4_1__);
    }
    eval 'sub _MM_FROUND_TO_NEAREST_INT () {0x;}' unless defined(&_MM_FROUND_TO_NEAREST_INT);
    eval 'sub _MM_FROUND_TO_NEG_INF () {0x1;}' unless defined(&_MM_FROUND_TO_NEG_INF);
    eval 'sub _MM_FROUND_TO_POS_INF () {0x2;}' unless defined(&_MM_FROUND_TO_POS_INF);
    eval 'sub _MM_FROUND_TO_ZERO () {0x3;}' unless defined(&_MM_FROUND_TO_ZERO);
    eval 'sub _MM_FROUND_CUR_DIRECTION () {0x4;}' unless defined(&_MM_FROUND_CUR_DIRECTION);
    eval 'sub _MM_FROUND_RAISE_EXC () {0x;}' unless defined(&_MM_FROUND_RAISE_EXC);
    eval 'sub _MM_FROUND_NO_EXC () {0x8;}' unless defined(&_MM_FROUND_NO_EXC);
    eval 'sub _MM_FROUND_NINT () {( &_MM_FROUND_TO_NEAREST_INT |  &_MM_FROUND_RAISE_EXC);}' unless defined(&_MM_FROUND_NINT);
    eval 'sub _MM_FROUND_FLOOR () {( &_MM_FROUND_TO_NEG_INF |  &_MM_FROUND_RAISE_EXC);}' unless defined(&_MM_FROUND_FLOOR);
    eval 'sub _MM_FROUND_CEIL () {( &_MM_FROUND_TO_POS_INF |  &_MM_FROUND_RAISE_EXC);}' unless defined(&_MM_FROUND_CEIL);
    eval 'sub _MM_FROUND_TRUNC () {( &_MM_FROUND_TO_ZERO |  &_MM_FROUND_RAISE_EXC);}' unless defined(&_MM_FROUND_TRUNC);
    eval 'sub _MM_FROUND_RINT () {( &_MM_FROUND_CUR_DIRECTION |  &_MM_FROUND_RAISE_EXC);}' unless defined(&_MM_FROUND_RINT);
    eval 'sub _MM_FROUND_NEARBYINT () {( &_MM_FROUND_CUR_DIRECTION |  &_MM_FROUND_NO_EXC);}' unless defined(&_MM_FROUND_NEARBYINT);
    eval 'sub _mm_test_all_zeros {
        my($M, $V) = @_;
	    eval q( &_mm_testz_si128 (($M), ($V)));
    }' unless defined(&_mm_test_all_zeros);
    eval 'sub _mm_test_all_ones {
        my($V) = @_;
	    eval q( &_mm_testc_si128 (($V),  &_mm_cmpeq_epi32 (($V), ($V))));
    }' unless defined(&_mm_test_all_ones);
    eval 'sub _mm_test_mix_ones_zeros {
        my($M, $V) = @_;
	    eval q( &_mm_testnzc_si128 (($M), ($V)));
    }' unless defined(&_mm_test_mix_ones_zeros);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_round_pd ( &__m128d  &__V,  &const \'int\'  &__M) { ( &__m128d)  &__builtin_ia32_roundpd (( &__v2df) &__V,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_round_sd( &__m128d  &__D,  &__m128d  &__V,  &const \'int\'  &__M) { ( &__m128d)  &__builtin_ia32_roundsd (( &__v2df) &__D, ( &__v2df) &__V,  &__M); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_round_pd {
	    my($V, $M) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_roundpd (( &__v2df)( &__m128d), ($M))));
	}' unless defined(&_mm_round_pd);
	eval 'sub _mm_round_sd {
	    my($D, $V, $M) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_roundsd (( &__v2df)( &__m128d)($D), ( &__v2df)( &__m128d), ($M))));
	}' unless defined(&_mm_round_sd);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_round_ps ( &__m128  &__V,  &const \'int\'  &__M) { ( &__m128)  &__builtin_ia32_roundps (( &__v4sf) &__V,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_round_ss ( &__m128  &__D,  &__m128  &__V,  &const \'int\'  &__M) { ( &__m128)  &__builtin_ia32_roundss (( &__v4sf) &__D, ( &__v4sf) &__V,  &__M); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_round_ps {
	    my($V, $M) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_roundps (( &__v4sf)( &__m128), ($M))));
	}' unless defined(&_mm_round_ps);
	eval 'sub _mm_round_ss {
	    my($D, $V, $M) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_roundss (( &__v4sf)( &__m128)($D), ( &__v4sf)( &__m128), ($M))));
	}' unless defined(&_mm_round_ss);
    }
    eval 'sub _mm_ceil_pd {
        my($V) = @_;
	    eval q( &_mm_round_pd (($V),  &_MM_FROUND_CEIL));
    }' unless defined(&_mm_ceil_pd);
    eval 'sub _mm_ceil_sd {
        my($D, $V) = @_;
	    eval q( &_mm_round_sd (($D), ($V),  &_MM_FROUND_CEIL));
    }' unless defined(&_mm_ceil_sd);
    eval 'sub _mm_floor_pd {
        my($V) = @_;
	    eval q( &_mm_round_pd(($V),  &_MM_FROUND_FLOOR));
    }' unless defined(&_mm_floor_pd);
    eval 'sub _mm_floor_sd {
        my($D, $V) = @_;
	    eval q( &_mm_round_sd (($D), ($V),  &_MM_FROUND_FLOOR));
    }' unless defined(&_mm_floor_sd);
    eval 'sub _mm_ceil_ps {
        my($V) = @_;
	    eval q( &_mm_round_ps (($V),  &_MM_FROUND_CEIL));
    }' unless defined(&_mm_ceil_ps);
    eval 'sub _mm_ceil_ss {
        my($D, $V) = @_;
	    eval q( &_mm_round_ss (($D), ($V),  &_MM_FROUND_CEIL));
    }' unless defined(&_mm_ceil_ss);
    eval 'sub _mm_floor_ps {
        my($V) = @_;
	    eval q( &_mm_round_ps (($V),  &_MM_FROUND_FLOOR));
    }' unless defined(&_mm_floor_ps);
    eval 'sub _mm_floor_ss {
        my($D, $V) = @_;
	    eval q( &_mm_round_ss (($D), ($V),  &_MM_FROUND_FLOOR));
    }' unless defined(&_mm_floor_ss);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_blend_epi16 ( &__m128i  &__X,  &__m128i  &__Y,  &const \'int\'  &__M) { ( &__m128i)  &__builtin_ia32_pblendw128 (( &__v8hi) &__X, ( &__v8hi) &__Y,  &__M); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_blend_epi16 {
	    my($X, $Y, $M) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_pblendw128 (( &__v8hi)( &__m128i)($X), ( &__v8hi)( &__m128i), ($M))));
	}' unless defined(&_mm_blend_epi16);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_blendv_epi8 ( &__m128i  &__X,  &__m128i  &__Y,  &__m128i  &__M) { ( &__m128i)  &__builtin_ia32_pblendvb128 (( &__v16qi) &__X, ( &__v16qi) &__Y, ( &__v16qi) &__M); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_blend_ps ( &__m128  &__X,  &__m128  &__Y,  &const \'int\'  &__M) { ( &__m128)  &__builtin_ia32_blendps (( &__v4sf) &__X, ( &__v4sf) &__Y,  &__M); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_blend_ps {
	    my($X, $Y, $M) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_blendps (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128), ($M))));
	}' unless defined(&_mm_blend_ps);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_blendv_ps ( &__m128  &__X,  &__m128  &__Y,  &__m128  &__M) { ( &__m128)  &__builtin_ia32_blendvps (( &__v4sf) &__X, ( &__v4sf) &__Y, ( &__v4sf) &__M); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_blend_pd ( &__m128d  &__X,  &__m128d  &__Y,  &const \'int\'  &__M) { ( &__m128d)  &__builtin_ia32_blendpd (( &__v2df) &__X, ( &__v2df) &__Y,  &__M); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_blend_pd {
	    my($X, $Y, $M) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_blendpd (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d), ($M))));
	}' unless defined(&_mm_blend_pd);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_blendv_pd ( &__m128d  &__X,  &__m128d  &__Y,  &__m128d  &__M) { ( &__m128d)  &__builtin_ia32_blendvpd (( &__v2df) &__X, ( &__v2df) &__Y, ( &__v2df) &__M); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_dp_ps ( &__m128  &__X,  &__m128  &__Y,  &const \'int\'  &__M) { ( &__m128)  &__builtin_ia32_dpps (( &__v4sf) &__X, ( &__v4sf) &__Y,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_dp_pd ( &__m128d  &__X,  &__m128d  &__Y,  &const \'int\'  &__M) { ( &__m128d)  &__builtin_ia32_dppd (( &__v2df) &__X, ( &__v2df) &__Y,  &__M); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_dp_ps {
	    my($X, $Y, $M) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_dpps (( &__v4sf)( &__m128)($X), ( &__v4sf)( &__m128), ($M))));
	}' unless defined(&_mm_dp_ps);
	eval 'sub _mm_dp_pd {
	    my($X, $Y, $M) = @_;
    	    eval q((( &__m128d)  &__builtin_ia32_dppd (( &__v2df)( &__m128d)($X), ( &__v2df)( &__m128d), ($M))));
	}' unless defined(&_mm_dp_pd);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_max_epi8 ( &__m128i  &__X,  &__m128i  &__Y) { ( &__m128i)  &__builtin_ia32_pmaxsb128 (( &__v16qi) &__X, ( &__v16qi) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_min_epu16 ( &__m128i  &__X,  &__m128i  &__Y) { ( &__m128i)  &__builtin_ia32_pminuw128 (( &__v8hi) &__X, ( &__v8hi) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_max_epu16 ( &__m128i  &__X,  &__m128i  &__Y) { ( &__m128i)  &__builtin_ia32_pmaxuw128 (( &__v8hi) &__X, ( &__v8hi) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_min_epi32 ( &__m128i  &__X,  &__m128i  &__Y) { ( &__m128i)  &__builtin_ia32_pminsd128 (( &__v4si) &__X, ( &__v4si) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_max_epi32 ( &__m128i  &__X,  &__m128i  &__Y) { ( &__m128i)  &__builtin_ia32_pmaxsd128 (( &__v4si) &__X, ( &__v4si) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_min_epu32 ( &__m128i  &__X,  &__m128i  &__Y) { ( &__m128i)  &__builtin_ia32_pminud128 (( &__v4si) &__X, ( &__v4si) &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_max_epu32 ( &__m128i  &__X,  &__m128i  &__Y) { ( &__m128i)  &__builtin_ia32_pmaxud128 (( &__v4si) &__X, ( &__v4si) &__Y); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_insert_ps ( &__m128  &__D,  &__m128  &__S,  &const \'int\'  &__N) { ( &__m128)  &__builtin_ia32_insertps128 (( &__v4sf) &__D, ( &__v4sf) &__S,  &__N); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_insert_ps {
	    my($D, $S, $N) = @_;
    	    eval q((( &__m128)  &__builtin_ia32_insertps128 (( &__v4sf)( &__m128)($D), ( &__v4sf)( &__m128), ($N))));
	}' unless defined(&_mm_insert_ps);
    }
    eval 'sub _MM_MK_INSERTPS_NDX {
        my($S, $D, $M) = @_;
	    eval q(((($S) << 6) | (($D) << 4) | ($M)));
    }' unless defined(&_MM_MK_INSERTPS_NDX);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_extract_ps ( &__m128  &__X,  &const \'int\'  &__N) { \'union union\' { \'int\'  &__i; \'float\'  &__f; }  &__tmp;  ($__tmp->{__f}) =  &__builtin_ia32_vec_ext_v4sf (( &__v4sf) &__X,  &__N);  ($__tmp->{__i}); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_extract_ps {
	    my($X, $N) = @_;
    	    eval q(( &__extension__ ({ \'union union\' { \'int\'  &__i; \'float\'  &__f; }  &__tmp;  ($__tmp->{__f}) =  &__builtin_ia32_vec_ext_v4sf (( &__v4sf)( &__m128), ($N));  ($__tmp->{__i}); })));
	}' unless defined(&_mm_extract_ps);
    }
    eval 'sub _MM_EXTRACT_FLOAT {
        my($D, $S, $N) = @_;
	    eval q({ ($D) =  &__builtin_ia32_vec_ext_v4sf (( &__v4sf)($S), ($N)); });
    }' unless defined(&_MM_EXTRACT_FLOAT);
    eval 'sub _MM_PICK_OUT_PS {
        my($X, $N) = @_;
	    eval q( &_mm_insert_ps ( &_mm_setzero_ps (), ($X),  &_MM_MK_INSERTPS_NDX (($N), 0, 0xe)));
    }' unless defined(&_MM_PICK_OUT_PS);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_insert_epi8 ( &__m128i  &__D, \'int\'  &__S,  &const \'int\'  &__N) { ( &__m128i)  &__builtin_ia32_vec_set_v16qi (( &__v16qi) &__D,  &__S,  &__N); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_insert_epi32 ( &__m128i  &__D, \'int\'  &__S,  &const \'int\'  &__N) { ( &__m128i)  &__builtin_ia32_vec_set_v4si (( &__v4si) &__D,  &__S,  &__N); });
	}' unless defined(&__attribute__);
	if(defined(&__x86_64__)) {
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_insert_epi64 ( &__m128i  &__D, my $__S,  &const \'int\'  &__N) { ( &__m128i)  &__builtin_ia32_vec_set_v2di (( &__v2di) &__D,  $__S,  &__N); });
	    }' unless defined(&__attribute__);
	}
    } else {
	eval 'sub _mm_insert_epi8 {
	    my($D, $S, $N) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_vec_set_v16qi (( &__v16qi)( &__m128i), , ($N))));
	}' unless defined(&_mm_insert_epi8);
	eval 'sub _mm_insert_epi32 {
	    my($D, $S, $N) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_vec_set_v4si (( &__v4si)( &__m128i), , ($N))));
	}' unless defined(&_mm_insert_epi32);
	if(defined(&__x86_64__)) {
	    eval 'sub _mm_insert_epi64 {
	        my($D, $S, $N) = @_;
    		eval q((( &__m128i)  &__builtin_ia32_vec_set_v2di (( &__v2di)( &__m128i), , ($N))));
	    }' unless defined(&_mm_insert_epi64);
	}
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_extract_epi8 ( &__m128i  &__X,  &const \'int\'  &__N) {  &__builtin_ia32_vec_ext_v16qi (( &__v16qi) &__X,  &__N); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_extract_epi32 ( &__m128i  &__X,  &const \'int\'  &__N) {  &__builtin_ia32_vec_ext_v4si (( &__v4si) &__X,  &__N); });
	}' unless defined(&__attribute__);
	if(defined(&__x86_64__)) {
	    eval 'sub __attribute__ () {
	        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_extract_epi64 ( &__m128i  &__X,  &const \'int\'  &__N) {  &__builtin_ia32_vec_ext_v2di (( &__v2di) &__X,  &__N); });
	    }' unless defined(&__attribute__);
	}
    } else {
	eval 'sub _mm_extract_epi8 {
	    my($X, $N) = @_;
    	    eval q((  &__builtin_ia32_vec_ext_v16qi (( &__v16qi)( &__m128i), ($N))));
	}' unless defined(&_mm_extract_epi8);
	eval 'sub _mm_extract_epi32 {
	    my($X, $N) = @_;
    	    eval q((  &__builtin_ia32_vec_ext_v4si (( &__v4si)( &__m128i), ($N))));
	}' unless defined(&_mm_extract_epi32);
	if(defined(&__x86_64__)) {
	    eval 'sub _mm_extract_epi64 {
	        my($X, $N) = @_;
    		eval q((  &__builtin_ia32_vec_ext_v2di (( &__v2di)( &__m128i), ($N))));
	    }' unless defined(&_mm_extract_epi64);
	}
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepi16_epi32 ( &__m128i  &__X) { ( &__m128i)  &__builtin_ia32_pmovsxwd128 (( &__v8hi) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepi8_epi64 ( &__m128i  &__X) { ( &__m128i)  &__builtin_ia32_pmovsxbq128 (( &__v16qi) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepi32_epi64 ( &__m128i  &__X) { ( &__m128i)  &__builtin_ia32_pmovsxdq128 (( &__v4si) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepi16_epi64 ( &__m128i  &__X) { ( &__m128i)  &__builtin_ia32_pmovsxwq128 (( &__v8hi) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepi8_epi16 ( &__m128i  &__X) { ( &__m128i)  &__builtin_ia32_pmovsxbw128 (( &__v16qi) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepu16_epi32 ( &__m128i  &__X) { ( &__m128i)  &__builtin_ia32_pmovzxwd128 (( &__v8hi) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepu8_epi64 ( &__m128i  &__X) { ( &__m128i)  &__builtin_ia32_pmovzxbq128 (( &__v16qi) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepu32_epi64 ( &__m128i  &__X) { ( &__m128i)  &__builtin_ia32_pmovzxdq128 (( &__v4si) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepu16_epi64 ( &__m128i  &__X) { ( &__m128i)  &__builtin_ia32_pmovzxwq128 (( &__v8hi) &__X); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cvtepu8_epi16 ( &__m128i  &__X) { ( &__m128i)  &__builtin_ia32_pmovzxbw128 (( &__v16qi) &__X); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_mpsadbw_epu8 ( &__m128i  &__X,  &__m128i  &__Y,  &const \'int\'  &__M) { ( &__m128i)  &__builtin_ia32_mpsadbw128 (( &__v16qi) &__X, ( &__v16qi) &__Y,  &__M); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_mpsadbw_epu8 {
	    my($X, $Y, $M) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_mpsadbw128 (( &__v16qi)( &__m128i)($X), ( &__v16qi)( &__m128i), ($M))));
	}' unless defined(&_mm_mpsadbw_epu8);
    }
    unless(defined(&__SSE4_2__)) {
	eval 'sub __DISABLE_SSE4_2__ () {1;}' unless defined(&__DISABLE_SSE4_2__);
    }
    eval 'sub _SIDD_UBYTE_OPS () {0x;}' unless defined(&_SIDD_UBYTE_OPS);
    eval 'sub _SIDD_UWORD_OPS () {0x1;}' unless defined(&_SIDD_UWORD_OPS);
    eval 'sub _SIDD_SBYTE_OPS () {0x2;}' unless defined(&_SIDD_SBYTE_OPS);
    eval 'sub _SIDD_SWORD_OPS () {0x3;}' unless defined(&_SIDD_SWORD_OPS);
    eval 'sub _SIDD_CMP_EQUAL_ANY () {0x;}' unless defined(&_SIDD_CMP_EQUAL_ANY);
    eval 'sub _SIDD_CMP_RANGES () {0x4;}' unless defined(&_SIDD_CMP_RANGES);
    eval 'sub _SIDD_CMP_EQUAL_EACH () {0x8;}' unless defined(&_SIDD_CMP_EQUAL_EACH);
    eval 'sub _SIDD_CMP_EQUAL_ORDERED () {0xc;}' unless defined(&_SIDD_CMP_EQUAL_ORDERED);
    eval 'sub _SIDD_POSITIVE_POLARITY () {0x;}' unless defined(&_SIDD_POSITIVE_POLARITY);
    eval 'sub _SIDD_NEGATIVE_POLARITY () {0x10;}' unless defined(&_SIDD_NEGATIVE_POLARITY);
    eval 'sub _SIDD_MASKED_POSITIVE_POLARITY () {0x20;}' unless defined(&_SIDD_MASKED_POSITIVE_POLARITY);
    eval 'sub _SIDD_MASKED_NEGATIVE_POLARITY () {0x30;}' unless defined(&_SIDD_MASKED_NEGATIVE_POLARITY);
    eval 'sub _SIDD_LEAST_SIGNIFICANT () {0x;}' unless defined(&_SIDD_LEAST_SIGNIFICANT);
    eval 'sub _SIDD_MOST_SIGNIFICANT () {0x40;}' unless defined(&_SIDD_MOST_SIGNIFICANT);
    eval 'sub _SIDD_BIT_MASK () {0x;}' unless defined(&_SIDD_BIT_MASK);
    eval 'sub _SIDD_UNIT_MASK () {0x40;}' unless defined(&_SIDD_UNIT_MASK);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpistrm ( &__m128i  &__X,  &__m128i  &__Y,  &const \'int\'  &__M) { ( &__m128i)  &__builtin_ia32_pcmpistrm128 (( &__v16qi) &__X, ( &__v16qi) &__Y,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpistri ( &__m128i  &__X,  &__m128i  &__Y,  &const \'int\'  &__M) {  &__builtin_ia32_pcmpistri128 (( &__v16qi) &__X, ( &__v16qi) &__Y,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpestrm ( &__m128i  &__X, \'int\'  &__LX,  &__m128i  &__Y, \'int\'  &__LY,  &const \'int\'  &__M) { ( &__m128i)  &__builtin_ia32_pcmpestrm128 (( &__v16qi) &__X,  &__LX, ( &__v16qi) &__Y,  &__LY,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpestri ( &__m128i  &__X, \'int\'  &__LX,  &__m128i  &__Y, \'int\'  &__LY,  &const \'int\'  &__M) {  &__builtin_ia32_pcmpestri128 (( &__v16qi) &__X,  &__LX, ( &__v16qi) &__Y,  &__LY,  &__M); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_cmpistrm {
	    my($X, $Y, $M) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_pcmpistrm128 (( &__v16qi)( &__m128i)($X), ( &__v16qi)( &__m128i), ($M))));
	}' unless defined(&_mm_cmpistrm);
	eval 'sub _mm_cmpistri {
	    my($X, $Y, $M) = @_;
    	    eval q((  &__builtin_ia32_pcmpistri128 (( &__v16qi)( &__m128i)($X), ( &__v16qi)( &__m128i), ($M))));
	}' unless defined(&_mm_cmpistri);
	eval 'sub _mm_cmpestrm {
	    my($X, $LX, $Y, $LY, $M) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_pcmpestrm128 (( &__v16qi)( &__m128i), ($LX), ( &__v16qi)( &__m128i), , ($M))));
	}' unless defined(&_mm_cmpestrm);
	eval 'sub _mm_cmpestri {
	    my($X, $LX, $Y, $LY, $M) = @_;
    	    eval q((  &__builtin_ia32_pcmpestri128 (( &__v16qi)( &__m128i), ($LX), ( &__v16qi)( &__m128i), , ($M))));
	}' unless defined(&_mm_cmpestri);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpistra ( &__m128i  &__X,  &__m128i  &__Y,  &const \'int\'  &__M) {  &__builtin_ia32_pcmpistria128 (( &__v16qi) &__X, ( &__v16qi) &__Y,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpistrc ( &__m128i  &__X,  &__m128i  &__Y,  &const \'int\'  &__M) {  &__builtin_ia32_pcmpistric128 (( &__v16qi) &__X, ( &__v16qi) &__Y,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpistro ( &__m128i  &__X,  &__m128i  &__Y,  &const \'int\'  &__M) {  &__builtin_ia32_pcmpistrio128 (( &__v16qi) &__X, ( &__v16qi) &__Y,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpistrs ( &__m128i  &__X,  &__m128i  &__Y,  &const \'int\'  &__M) {  &__builtin_ia32_pcmpistris128 (( &__v16qi) &__X, ( &__v16qi) &__Y,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpistrz ( &__m128i  &__X,  &__m128i  &__Y,  &const \'int\'  &__M) {  &__builtin_ia32_pcmpistriz128 (( &__v16qi) &__X, ( &__v16qi) &__Y,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpestra ( &__m128i  &__X, \'int\'  &__LX,  &__m128i  &__Y, \'int\'  &__LY,  &const \'int\'  &__M) {  &__builtin_ia32_pcmpestria128 (( &__v16qi) &__X,  &__LX, ( &__v16qi) &__Y,  &__LY,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpestrc ( &__m128i  &__X, \'int\'  &__LX,  &__m128i  &__Y, \'int\'  &__LY,  &const \'int\'  &__M) {  &__builtin_ia32_pcmpestric128 (( &__v16qi) &__X,  &__LX, ( &__v16qi) &__Y,  &__LY,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpestro ( &__m128i  &__X, \'int\'  &__LX,  &__m128i  &__Y, \'int\'  &__LY,  &const \'int\'  &__M) {  &__builtin_ia32_pcmpestrio128 (( &__v16qi) &__X,  &__LX, ( &__v16qi) &__Y,  &__LY,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpestrs ( &__m128i  &__X, \'int\'  &__LX,  &__m128i  &__Y, \'int\'  &__LY,  &const \'int\'  &__M) {  &__builtin_ia32_pcmpestris128 (( &__v16qi) &__X,  &__LX, ( &__v16qi) &__Y,  &__LY,  &__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_cmpestrz ( &__m128i  &__X, \'int\'  &__LX,  &__m128i  &__Y, \'int\'  &__LY,  &const \'int\'  &__M) {  &__builtin_ia32_pcmpestriz128 (( &__v16qi) &__X,  &__LX, ( &__v16qi) &__Y,  &__LY,  &__M); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_cmpistra {
	    my($X, $Y, $M) = @_;
    	    eval q((  &__builtin_ia32_pcmpistria128 (( &__v16qi)( &__m128i)($X), ( &__v16qi)( &__m128i), ($M))));
	}' unless defined(&_mm_cmpistra);
	eval 'sub _mm_cmpistrc {
	    my($X, $Y, $M) = @_;
    	    eval q((  &__builtin_ia32_pcmpistric128 (( &__v16qi)( &__m128i)($X), ( &__v16qi)( &__m128i), ($M))));
	}' unless defined(&_mm_cmpistrc);
	eval 'sub _mm_cmpistro {
	    my($X, $Y, $M) = @_;
    	    eval q((  &__builtin_ia32_pcmpistrio128 (( &__v16qi)( &__m128i)($X), ( &__v16qi)( &__m128i), ($M))));
	}' unless defined(&_mm_cmpistro);
	eval 'sub _mm_cmpistrs {
	    my($X, $Y, $M) = @_;
    	    eval q((  &__builtin_ia32_pcmpistris128 (( &__v16qi)( &__m128i)($X), ( &__v16qi)( &__m128i), ($M))));
	}' unless defined(&_mm_cmpistrs);
	eval 'sub _mm_cmpistrz {
	    my($X, $Y, $M) = @_;
    	    eval q((  &__builtin_ia32_pcmpistriz128 (( &__v16qi)( &__m128i)($X), ( &__v16qi)( &__m128i), ($M))));
	}' unless defined(&_mm_cmpistrz);
	eval 'sub _mm_cmpestra {
	    my($X, $LX, $Y, $LY, $M) = @_;
    	    eval q((  &__builtin_ia32_pcmpestria128 (( &__v16qi)( &__m128i), ($LX), ( &__v16qi)( &__m128i), , ($M))));
	}' unless defined(&_mm_cmpestra);
	eval 'sub _mm_cmpestrc {
	    my($X, $LX, $Y, $LY, $M) = @_;
    	    eval q((  &__builtin_ia32_pcmpestric128 (( &__v16qi)( &__m128i), ($LX), ( &__v16qi)( &__m128i), , ($M))));
	}' unless defined(&_mm_cmpestrc);
	eval 'sub _mm_cmpestro {
	    my($X, $LX, $Y, $LY, $M) = @_;
    	    eval q((  &__builtin_ia32_pcmpestrio128 (( &__v16qi)( &__m128i), ($LX), ( &__v16qi)( &__m128i), , ($M))));
	}' unless defined(&_mm_cmpestro);
	eval 'sub _mm_cmpestrs {
	    my($X, $LX, $Y, $LY, $M) = @_;
    	    eval q((  &__builtin_ia32_pcmpestris128 (( &__v16qi)( &__m128i), ($LX), ( &__v16qi)( &__m128i), , ($M))));
	}' unless defined(&_mm_cmpestrs);
	eval 'sub _mm_cmpestrz {
	    my($X, $LX, $Y, $LY, $M) = @_;
    	    eval q((  &__builtin_ia32_pcmpestriz128 (( &__v16qi)( &__m128i), ($LX), ( &__v16qi)( &__m128i), , ($M))));
	}' unless defined(&_mm_cmpestrz);
    }
    if(defined(&__DISABLE_SSE4_2__)) {
	undef(&__DISABLE_SSE4_2__) if defined(&__DISABLE_SSE4_2__);
    }
    if(defined(&__DISABLE_SSE4_1__)) {
	undef(&__DISABLE_SSE4_1__) if defined(&__DISABLE_SSE4_1__);
    }
    require 'popcntintrin.ph';
    unless(defined(&__SSE4_1__)) {
	eval 'sub __DISABLE_SSE4_1__ () {1;}' unless defined(&__DISABLE_SSE4_1__);
    }
    unless(defined(&__SSE4_2__)) {
	eval 'sub __DISABLE_SSE4_2__ () {1;}' unless defined(&__DISABLE_SSE4_2__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_crc32_u16 (my $__C, my $__V) {  &__builtin_ia32_crc32hi ( $__C,  $__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_crc32_u32 (my $__C, my $__V) {  &__builtin_ia32_crc32si ( $__C,  $__V); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_crc32_u64 (my $__C, my $__V) {  &__builtin_ia32_crc32di ( $__C,  $__V); });
	}' unless defined(&__attribute__);
    }
    if(defined(&__DISABLE_SSE4_2__)) {
	undef(&__DISABLE_SSE4_2__) if defined(&__DISABLE_SSE4_2__);
    }
    if(defined(&__DISABLE_SSE4_1__)) {
	undef(&__DISABLE_SSE4_1__) if defined(&__DISABLE_SSE4_1__);
    }
}
1;
