require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__VAESINTRIN_H_INCLUDED)) {
    eval 'sub __VAESINTRIN_H_INCLUDED () {1;}' unless defined(&__VAESINTRIN_H_INCLUDED);
    if(!defined(&__VAES__) || !defined(&__AVX__)) {
	eval 'sub __DISABLE_VAES__ () {1;}' unless defined(&__DISABLE_VAES__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_aesdec_epi128 ( &__m256i  &__A,  &__m256i  &__B) { ( &__m256i) &__builtin_ia32_vaesdec_v32qi (( &__v32qi)  &__A, ( &__v32qi)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_aesdeclast_epi128 ( &__m256i  &__A,  &__m256i  &__B) { ( &__m256i) &__builtin_ia32_vaesdeclast_v32qi (( &__v32qi)  &__A, ( &__v32qi)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_aesenc_epi128 ( &__m256i  &__A,  &__m256i  &__B) { ( &__m256i) &__builtin_ia32_vaesenc_v32qi (( &__v32qi)  &__A, ( &__v32qi)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm256_aesenclast_epi128 ( &__m256i  &__A,  &__m256i  &__B) { ( &__m256i) &__builtin_ia32_vaesenclast_v32qi (( &__v32qi)  &__A, ( &__v32qi)  &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_VAES__)) {
	undef(&__DISABLE_VAES__) if defined(&__DISABLE_VAES__);
    }
    if(!defined(&__VAES__) || !defined(&__AVX512F__)) {
	eval 'sub __DISABLE_VAESF__ () {1;}' unless defined(&__DISABLE_VAESF__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_aesdec_epi128 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) &__builtin_ia32_vaesdec_v64qi (( &__v64qi)  &__A, ( &__v64qi)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_aesdeclast_epi128 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) &__builtin_ia32_vaesdeclast_v64qi (( &__v64qi)  &__A, ( &__v64qi)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_aesenc_epi128 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) &__builtin_ia32_vaesenc_v64qi (( &__v64qi)  &__A, ( &__v64qi)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_aesenclast_epi128 ( &__m512i  &__A,  &__m512i  &__B) { ( &__m512i) &__builtin_ia32_vaesenclast_v64qi (( &__v64qi)  &__A, ( &__v64qi)  &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_VAESF__)) {
	undef(&__DISABLE_VAESF__) if defined(&__DISABLE_VAESF__);
    }
}
1;
