require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub ELF32_MACHDEP_ENDIANNESS () { &ELFDATA2LSB;}' unless defined(&ELF32_MACHDEP_ENDIANNESS);
eval 'sub ELF32_MACHDEP_ID_CASES () { &case  &EM_386:  &case  &EM_486:  &break;;}' unless defined(&ELF32_MACHDEP_ID_CASES);
eval 'sub ELF64_MACHDEP_ENDIANNESS () { &XXX;}' unless defined(&ELF64_MACHDEP_ENDIANNESS);
eval 'sub ELF64_MACHDEP_ID_CASES () {1;}' unless defined(&ELF64_MACHDEP_ID_CASES);
eval 'sub ELF32_MACHDEP_ID () { &EM_386;}' unless defined(&ELF32_MACHDEP_ID);
eval 'sub KERN_ELFSIZE () {32;}' unless defined(&KERN_ELFSIZE);
eval 'sub ARCH_ELFSIZE () {32;}' unless defined(&ARCH_ELFSIZE);
eval 'sub R_386_NONE () {0;}' unless defined(&R_386_NONE);
eval 'sub R_386_32 () {1;}' unless defined(&R_386_32);
eval 'sub R_386_PC32 () {2;}' unless defined(&R_386_PC32);
eval 'sub R_386_GOT32 () {3;}' unless defined(&R_386_GOT32);
eval 'sub R_386_PLT32 () {4;}' unless defined(&R_386_PLT32);
eval 'sub R_386_COPY () {5;}' unless defined(&R_386_COPY);
eval 'sub R_386_GLOB_DAT () {6;}' unless defined(&R_386_GLOB_DAT);
eval 'sub R_386_JMP_SLOT () {7;}' unless defined(&R_386_JMP_SLOT);
eval 'sub R_386_RELATIVE () {8;}' unless defined(&R_386_RELATIVE);
eval 'sub R_386_GOTOFF () {9;}' unless defined(&R_386_GOTOFF);
eval 'sub R_386_GOTPC () {10;}' unless defined(&R_386_GOTPC);
eval 'sub R_386_32PLT () {11;}' unless defined(&R_386_32PLT);
eval 'sub R_386_TLS_TPOFF () {14;}' unless defined(&R_386_TLS_TPOFF);
eval 'sub R_386_TLS_IE () {15;}' unless defined(&R_386_TLS_IE);
eval 'sub R_386_TLS_GOTIE () {16;}' unless defined(&R_386_TLS_GOTIE);
eval 'sub R_386_TLS_LE () {17;}' unless defined(&R_386_TLS_LE);
eval 'sub R_386_TLS_GD () {18;}' unless defined(&R_386_TLS_GD);
eval 'sub R_386_TLS_LDM () {19;}' unless defined(&R_386_TLS_LDM);
eval 'sub R_386_16 () {20;}' unless defined(&R_386_16);
eval 'sub R_386_PC16 () {21;}' unless defined(&R_386_PC16);
eval 'sub R_386_8 () {22;}' unless defined(&R_386_8);
eval 'sub R_386_PC8 () {23;}' unless defined(&R_386_PC8);
eval 'sub R_386_TLS_GD_32 () {24;}' unless defined(&R_386_TLS_GD_32);
eval 'sub R_386_TLS_GD_PUSH () {25;}' unless defined(&R_386_TLS_GD_PUSH);
eval 'sub R_386_TLS_GD_CALL () {26;}' unless defined(&R_386_TLS_GD_CALL);
eval 'sub R_386_TLS_GD_POP () {27;}' unless defined(&R_386_TLS_GD_POP);
eval 'sub R_386_TLS_LDM_32 () {28;}' unless defined(&R_386_TLS_LDM_32);
eval 'sub R_386_TLS_LDM_PUSH () {29;}' unless defined(&R_386_TLS_LDM_PUSH);
eval 'sub R_386_TLS_LDM_CALL () {30;}' unless defined(&R_386_TLS_LDM_CALL);
eval 'sub R_386_TLS_LDM_POP () {31;}' unless defined(&R_386_TLS_LDM_POP);
eval 'sub R_386_TLS_LDO_32 () {32;}' unless defined(&R_386_TLS_LDO_32);
eval 'sub R_386_TLS_IE_32 () {33;}' unless defined(&R_386_TLS_IE_32);
eval 'sub R_386_TLS_LE_32 () {34;}' unless defined(&R_386_TLS_LE_32);
eval 'sub R_386_TLS_DTPMOD32 () {35;}' unless defined(&R_386_TLS_DTPMOD32);
eval 'sub R_386_TLS_DTPOFF32 () {36;}' unless defined(&R_386_TLS_DTPOFF32);
eval 'sub R_386_TLS_TPOFF32 () {37;}' unless defined(&R_386_TLS_TPOFF32);
eval 'sub R_386_SIZE32 () {38;}' unless defined(&R_386_SIZE32);
eval 'sub R_386_TLS_GOTDESC () {39;}' unless defined(&R_386_TLS_GOTDESC);
eval 'sub R_386_TLS_DESC_CALL () {40;}' unless defined(&R_386_TLS_DESC_CALL);
eval 'sub R_386_TLS_DESC () {41;}' unless defined(&R_386_TLS_DESC);
eval 'sub R_386_IRELATIVE () {42;}' unless defined(&R_386_IRELATIVE);
eval 'sub R_386_GOT32X () {43;}' unless defined(&R_386_GOT32X);
unless(defined(&R_TYPE)) {
    sub R_TYPE {
	my($name) = @_;
	eval q( &__CONCAT( &R_386_,$name));
    }
}
1;
