require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_I386_PTRACE_H_)) {
    eval 'sub _I386_PTRACE_H_ () {1;}' unless defined(&_I386_PTRACE_H_);
    eval 'sub PT_STEP () {( &PT_FIRSTMACH + 0);}' unless defined(&PT_STEP);
    eval 'sub PT_GETREGS () {( &PT_FIRSTMACH + 1);}' unless defined(&PT_GETREGS);
    eval 'sub PT_SETREGS () {( &PT_FIRSTMACH + 2);}' unless defined(&PT_SETREGS);
    eval 'sub PT_GETFPREGS () {( &PT_FIRSTMACH + 3);}' unless defined(&PT_GETFPREGS);
    eval 'sub PT_SETFPREGS () {( &PT_FIRSTMACH + 4);}' unless defined(&PT_SETFPREGS);
    eval 'sub __HAVE_PTRACE_MACHDEP () {1;}' unless defined(&__HAVE_PTRACE_MACHDEP);
    eval 'sub __HAVE_PROCFS_MACHDEP () {1;}' unless defined(&__HAVE_PROCFS_MACHDEP);
    eval 'sub PT_GETXMMREGS () {( &PT_FIRSTMACH + 5);}' unless defined(&PT_GETXMMREGS);
    eval 'sub PT_SETXMMREGS () {( &PT_FIRSTMACH + 6);}' unless defined(&PT_SETXMMREGS);
    eval 'sub PT_GETDBREGS () {( &PT_FIRSTMACH + 7);}' unless defined(&PT_GETDBREGS);
    eval 'sub PT_SETDBREGS () {( &PT_FIRSTMACH + 8);}' unless defined(&PT_SETDBREGS);
    eval 'sub PT_SETSTEP () {( &PT_FIRSTMACH + 9);}' unless defined(&PT_SETSTEP);
    eval 'sub PT_CLEARSTEP () {( &PT_FIRSTMACH + 10);}' unless defined(&PT_CLEARSTEP);
    eval 'sub PT_GETXSTATE () {( &PT_FIRSTMACH + 11);}' unless defined(&PT_GETXSTATE);
    eval 'sub PT_SETXSTATE () {( &PT_FIRSTMACH + 12);}' unless defined(&PT_SETXSTATE);
    eval 'sub PT_MACHDEP_STRINGS () {"PT_STEP", "PT_GETREGS", "PT_SETREGS", "PT_GETFPREGS", "PT_SETFPREGS", "PT_GETXMMREGS", "PT_SETXMMREGS", "PT_GETDBREGS", "PT_SETDBREGS", "PT_SETSTEP", "PT_CLEARSTEP", "PT_GETXSTATE", "PT_SETXSTATE";}' unless defined(&PT_MACHDEP_STRINGS);
    require 'machine/reg.ph';
    eval 'sub PTRACE_REG_PC {
        my($r) = @_;
	    eval q(($r)-> &r_eip);
    }' unless defined(&PTRACE_REG_PC);
    eval 'sub PTRACE_REG_FP {
        my($r) = @_;
	    eval q(($r)-> &r_ebp);
    }' unless defined(&PTRACE_REG_FP);
    eval 'sub PTRACE_REG_SET_PC {
        my($r, $v) = @_;
	    eval q(($r)-> &r_eip = ($v));
    }' unless defined(&PTRACE_REG_SET_PC);
    eval 'sub PTRACE_REG_SP {
        my($r) = @_;
	    eval q(($r)-> &r_esp);
    }' unless defined(&PTRACE_REG_SP);
    eval 'sub PTRACE_REG_INTRV {
        my($r) = @_;
	    eval q(($r)-> &r_eax);
    }' unless defined(&PTRACE_REG_INTRV);
    eval 'sub PTRACE_ILLEGAL_ASM () { &__asm  &__volatile ("ud2" : : : "memory");}' unless defined(&PTRACE_ILLEGAL_ASM);
    eval 'sub PTRACE_BREAKPOINT () {(( &const  $uint8_t[]) { 0xcc });}' unless defined(&PTRACE_BREAKPOINT);
    eval 'sub PTRACE_BREAKPOINT_ASM () { &__asm  &__volatile ("int3" : : : "memory");}' unless defined(&PTRACE_BREAKPOINT_ASM);
    eval 'sub PTRACE_BREAKPOINT_SIZE () {1;}' unless defined(&PTRACE_BREAKPOINT_SIZE);
    eval 'sub PTRACE_BREAKPOINT_ADJ () {$sizeof{ &PTRACE_BREAKPOINT};}' unless defined(&PTRACE_BREAKPOINT_ADJ);
    if(defined(&_KERNEL)) {
	eval 'sub PTRACE_MACHDEP_REQUEST_CASES () { &case  &PT_GETXMMREGS:  &case  &PT_SETXMMREGS:  &case  &PT_GETXSTATE:  &case  &PT_SETXSTATE:;}' unless defined(&PTRACE_MACHDEP_REQUEST_CASES);
	eval 'sub PROCFS_MACHDEP_NODE_TYPES () { &Pmachdep_xmmregs,;}' unless defined(&PROCFS_MACHDEP_NODE_TYPES);
	eval 'sub PROCFS_MACHDEP_NODETYPE_CASES () { &case  &Pmachdep_xmmregs:;}' unless defined(&PROCFS_MACHDEP_NODETYPE_CASES);
	eval 'sub PROCFS_MACHDEP_PROTECT_CASES () { &case  &Pmachdep_xmmregs:;}' unless defined(&PROCFS_MACHDEP_PROTECT_CASES);
	eval 'sub PROCFS_MACHDEP_NODETYPE_DEFNS () {{  &DT_REG,  &N("xmmregs"),  &Pmachdep_xmmregs,  &procfs_machdep_validxmmregs },;}' unless defined(&PROCFS_MACHDEP_NODETYPE_DEFNS);
	eval 'sub PT32_GETXSTATE () { &PT_GETXSTATE;}' unless defined(&PT32_GETXSTATE);
	eval 'sub COREDUMP_MACHDEP_LWP_NOTES {
	    my($l, $ns, $name) = @_;
    	    eval q({ \'struct xstate\'  &xstate;  &memset( &xstate, 0, $sizeof{ &xstate});  &if (! &process_read_xstate($l,  &xstate)) {  &ELFNAMEEND( &coredump_savenote)($ns,  &CONCAT( &CONCAT( &PT,  &ELFSIZE),  &_GETXSTATE), $name,  &xstate, $sizeof{ &xstate}); } });
	}' unless defined(&COREDUMP_MACHDEP_LWP_NOTES);
	eval 'sub PTRACE_REGS_ALIGN () { &__aligned(16);}' unless defined(&PTRACE_REGS_ALIGN);
    }
}
1;
