require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_FLOAT_H_)) {
    eval 'sub _X86_FLOAT_H_ () {1;}' unless defined(&_X86_FLOAT_H_);
    require 'sys/featuretest.ph';
    eval 'sub LDBL_MANT_DIG () {64;}' unless defined(&LDBL_MANT_DIG);
    eval 'sub LDBL_EPSILON () {1.0842021724855044340E-19;}' unless defined(&LDBL_EPSILON);
    eval 'sub LDBL_DIG () {18;}' unless defined(&LDBL_DIG);
    eval 'sub LDBL_MIN_EXP () {(-16381);}' unless defined(&LDBL_MIN_EXP);
    eval 'sub LDBL_MIN () {3.3621031431120935063E-4932;}' unless defined(&LDBL_MIN);
    eval 'sub LDBL_MIN_10_EXP () {(-4931);}' unless defined(&LDBL_MIN_10_EXP);
    eval 'sub LDBL_MAX_EXP () {16384;}' unless defined(&LDBL_MAX_EXP);
    eval 'sub LDBL_MAX () {1.1897314953572317650E+4932;}' unless defined(&LDBL_MAX);
    eval 'sub LDBL_MAX_10_EXP () {4932;}' unless defined(&LDBL_MAX_10_EXP);
    require 'sys/float_ieee754.ph';
    if(!defined(&_ANSI_SOURCE)  && !defined(&_POSIX_C_SOURCE)  && !defined(&_XOPEN_SOURCE) || (((defined(&__STDC_VERSION__) ? &__STDC_VERSION__ : undef) - 0) >= 199901) || (((defined(&_POSIX_C_SOURCE) ? &_POSIX_C_SOURCE : undef) - 0) >= 200112) || (((defined(&_XOPEN_SOURCE) ? &_XOPEN_SOURCE : undef) - 0) >= 600) || defined(&_ISOC99_SOURCE) || defined(&_NETBSD_SOURCE)) {
	eval 'sub DECIMAL_DIG () {21;}' unless defined(&DECIMAL_DIG);
    }
}
1;
