require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/ieee754.ph';
eval 'sub EXT_EXPBITS () {15;}' unless defined(&EXT_EXPBITS);
eval 'sub EXT_FRACHBITS () {32;}' unless defined(&EXT_FRACHBITS);
eval 'sub EXT_FRACLBITS () {32;}' unless defined(&EXT_FRACLBITS);
eval 'sub EXT_FRACBITS () {( &EXT_FRACLBITS +  &EXT_FRACHBITS);}' unless defined(&EXT_FRACBITS);
unless(defined(&EXT_TO_ARRAY32)) {
    sub EXT_TO_ARRAY32 {
	my($u, $a) = @_;
	eval q( &do { ($a)[0] = ( &uint32_t)($u). ($extu_ext->{ext_fracl}); ($a)[1] = ( &uint32_t)($u). ($extu_ext->{ext_frach}); }  &while( 0));
    }
}
if(0) {
}
eval 'sub EXT_EXP_INFNAN () {0x7fff;}' unless defined(&EXT_EXP_INFNAN);
eval 'sub EXT_EXP_INF () {0x7fff;}' unless defined(&EXT_EXP_INF);
eval 'sub EXT_EXP_NAN () {0x7fff;}' unless defined(&EXT_EXP_NAN);
if(0) {
    eval 'sub SNG_QUIETNAN () {(1<< 22);}' unless defined(&SNG_QUIETNAN);
    eval 'sub DBL_QUIETNAN () {(1<< 19);}' unless defined(&DBL_QUIETNAN);
    eval 'sub EXT_QUIETNAN () {(1<< 30);}' unless defined(&EXT_QUIETNAN);
}
eval 'sub EXT_EXP_BIAS () {16383;}' unless defined(&EXT_EXP_BIAS);
eval 'sub extu_exp () { ($extu_ext->{ext_exp});}' unless defined(&extu_exp);
eval 'sub extu_sign () { ($extu_ext->{ext_sign});}' unless defined(&extu_sign);
eval 'sub extu_fracl () { ($extu_ext->{ext_fracl});}' unless defined(&extu_fracl);
eval 'sub extu_frach () { ($extu_ext->{ext_frach});}' unless defined(&extu_frach);
eval 'sub LDBL_NBIT () {0x80000000;}' unless defined(&LDBL_NBIT);
unless(defined(&mask_nbit_l)) {
    sub mask_nbit_l {
	my($u) = @_;
	eval q((($u). &extu_frach &= ~ &LDBL_NBIT));
    }
}
1;
