require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_XEN_INTRDEFS_H_)) {
    eval 'sub _XEN_INTRDEFS_H_ () {1;}' unless defined(&_XEN_INTRDEFS_H_);
    eval 'sub XEN_IPI_HALT () {0x1;}' unless defined(&XEN_IPI_HALT);
    eval 'sub XEN_IPI_SYNCH_FPU () {0x2;}' unless defined(&XEN_IPI_SYNCH_FPU);
    eval 'sub XEN_IPI_DDB () {0x4;}' unless defined(&XEN_IPI_DDB);
    eval 'sub XEN_IPI_XCALL () {0x8;}' unless defined(&XEN_IPI_XCALL);
    eval 'sub XEN_IPI_HVCB () {0x10;}' unless defined(&XEN_IPI_HVCB);
    eval 'sub XEN_IPI_GENERIC () {0x20;}' unless defined(&XEN_IPI_GENERIC);
    eval 'sub XEN_IPI_AST () {0x40;}' unless defined(&XEN_IPI_AST);
    eval 'sub XEN_IPI_KPREEMPT () {0x80;}' unless defined(&XEN_IPI_KPREEMPT);
    eval 'sub XEN_NIPIS () {8;}' unless defined(&XEN_NIPIS);
    eval 'sub NUM_XEN_IRQS () {256;}' unless defined(&NUM_XEN_IRQS);
    eval 'sub XEN_IPI_NAMES () {{ "halt IPI", "FPU synch IPI", "DDB IPI", "xcall IPI", "HVCB IPI", "generic IPI", "AST IPI", "kpreempt IPI" };}' unless defined(&XEN_IPI_NAMES);
}
1;
